@REM - ASB (17 Oct 2016 // 13 Sep 2023 / 23 Dec 2020 / 30 Nov 2020 / 26 May 2020 / 08 May 2020 / 06 Jan 2020 / 24 Dec 2019 / 10 Dec 2019 / 30 Sep 2019): List/Start/Stop/Restart/Show Bulk Services Based On Search String
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v2.4.0.260

 rem -- Display Syntax Help if Required/Requested
 CHECKPARAMS --rc --mp=2 -c "H HELP ?" -x "?? H2" -s %*
 IF ERRORLEVEL 1 IF NOT ERRORLEVEL 16 GOTO :HelpMessage

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @COMMAND=LIST& FOR %%C IN (START STOP RESTART ENABLE DISABLE INFO) DO IF /I "%~1"=="%%~C" SET @COMMAND=%~1
 SET @STATUS-RESTART=STOPPING and STARTING
 SET @STATUS-STOP=STOPPING
 SET @STATUS-START=STARTING
 SET @STATUS-LIST=LISTING
 SET @STATUS-INFO=DISPLAYING
 SET @STATUS-ENABLE=ENABLING
 SET @STATUS-DISABLE=DISABLING
 SET @CONFIG-ENABLE=auto
 SET @CONFIG-DISABLE=disabled
 SET @VERIFY-ENABLE=DISABLED
 SET @VERIFY-DISABLE=AUTO_START
 SET @SEARCH=%~2
 SET @SEARCH=%@SEARCH:"=%
 SET @SVCLIST=
 SET @DELAY=5

 rem -- Process Special Command-line Parameters
 SET @ALL_PARAMS=%*
 CALL :GetParams "D DELAY" @DELAY & IF NOT DEFINED @DELAY (SET @DELAY=5)

 rem -- Determine if a Valid Command was Issued
:VerifyCommand
 SET @VALID_CMD=
 FOR %%E IN (LIST INFO START STOP RESTART ENABLE DISABLE) DO IF /I "%~1"=="%%~E" SET @VALID_CMD=TRUE
 IF NOT DEFINED @VALID_CMD (
	 ECHO *** INCORRECT COMMAND ISSUED: "%~1" ***
	 ECHO %@DIVIDER%
	 ECHO:
 )

 rem -- List/Start/Stop Services Containing Search String
:GetServices
 ECHO !@STATUS-%@COMMAND%! Services Containing: "%@SEARCH%"
 ECHO %@DIVIDER-%
 FOR /F "TOKENS=1*" %%a IN ('PSSERVICE %@PSPARAMS% QUERY ^| FIND /I "%@SEARCH%" ^| FIND /I "_NAME" ') DO (
	 FOR /F "TOKENS=1*" %%R IN ('PSSERVICE %@PSPARAMS% QUERY "%%~b" ^| FIND /I "SERVICE_NAME"') DO SET #SVC-%%S=%%S
 )

 FOR /F "TOKENS=1* DELIMS==" %%R IN ('SET #SVC- 2^>NUL') DO (
	 FOR %%E IN (ENABLE DISABLE) DO IF /I "%@COMMAND%"=="%%~E" (
		 ECHO  -- !@STATUS-%@COMMAND%! %%S
		 FOR /F "TOKENS=3" %%v IN ('PSSERVICE %@PSPARAMS% CONFIG %%S ^| FIND "START_TYPE"') DO SET @STARTUP=%%v
		 PSSERVICE %@PSPARAMS% SETCONFIG %%S !@CONFIG-%@COMMAND%! | FIND "\\"
		 ECHO:
		 ECHO:
	 )

	 FOR %%E IN (START STOP) DO IF /I "%@COMMAND%"=="%%~E" (
		 ECHO  -- !@STATUS-%@COMMAND%! %%S
		 NET %@COMMAND% "%%~S"
		 ECHO:
		 ECHO:
	 )

	 FOR %%E IN (RESTART) DO IF /I "%@COMMAND%"=="%%~E" (
		 ECHO  -- !@STATUS-%@COMMAND%! %%S
		 NET STOP "%%~S"
		 ECHO Waiting for %@DELAY% Seconds...
		 TIMEOUT %@DELAY%
		 ECHO:
		 NET START "%%~S"
		 ECHO:
		 ECHO:
	 )

	 FOR %%E IN (LIST INFO) DO IF /I "%@COMMAND%"=="%%~E" ECHO  %%S
	 IF /I NOT "%@COMMAND%"=="LIST" SET @SVCLIST=!@SVCLIST! "%%~S"
 )

 IF DEFINED @SVCLIST (
	 ECHO %@DIVIDER-%
	 ECHO:
	 FOR %%S IN (%@SVCLIST%) DO (
		 PSSERVICE QUERY %%S | FIND "DISPLAY_NAME"
		 FOR %%C IN (QC QUERY) DO SC %%C "%%~S" | FIND /V "[SC]"
		 ECHO %@DIVIDER-%
		 ECHO:
	 )
 )
 ECHO %@DIVIDER*%


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Use CheckParams.exe to Capture Selected Parameters
:GetParams
 rem %1 = Parameters to Search For
 rem %2 = Variable to Set

 SET @OK=& IF "%~1"=="" GOTO :EOF
 FOR /F "TOKENS=2-3*" %%v IN ('CHECKPARAMS -q -a -c "%~1" -s %@ALL_PARAMS% 2^>NUL') DO IF /I "%%~v"=="TRUE" (
	 SET @OK=T
	 SET @REQ=T
	 IF NOT "%~2"=="" SET %~2=%%~x
 )
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF


 rem -- SUBROUTINE: Display Syntax Help if Required/Requested
:HelpMessage
 ECHO List/Start/Stop/Restart/Show Bulk Services Based On Search String
 ECHO:
 ECHO ----------
 ECHO YOU TYPED:  %0 %*
 ECHO ----------
 ECHO:
 ECHO -----------
 ECHO CMD SYNTAX:
 ECHO -----------
 ECHO  %~n0  ^<options^> ^<search_string^> [OPTIONS]
 ECHO  %~n0  [-h^|-?^|-h2^|-??]
 ECHO:
 ECHO -------------------
 ECHO OPTION DEFINITIONS:
 ECHO -------------------
 ECHO  -?,  /H ..... Display This Help Message  (also --HELP)
 ECHO  -??, /H2 .... Display Extended Help Message
 ECHO  -D, /DELAY .. Set a delay interval between service STOP and RESTART
 ECHO:
 ECHO  For all services matching the search string, do the following:
 ECHO    LIST ...... List all services
 ECHO    INFO ...... Get detailed info for all services
 ECHO    START ..... Start all services
 ECHO    STOP ...... Stop all services
 ECHO    RESTART ... Stop AND Restart all services
 ECHO    ENABLE .... Set all services to AUTO start
 ECHO    DISABLE ... Set all services to DISABLED
 ECHO:

 IF ERRORLEVEL 8 IF NOT ERRORLEVEL 16 (
	 ECHO ----------------
	 ECHO SYNTAX EXAMPLES:
	 ECHO ----------------
	 ECHO  %~n0 LIST    Microsoft
	 ECHO  %~n0 INFO    Intel
	 ECHO  %~n0 START   MSExchange
	 ECHO  %~n0 RESTART URB /D:10
	 ECHO:
	 ECHO ------------
	 ECHO USAGE NOTES:
	 ECHO ------------
	 ECHO  * Parameters surrounded by ^<^> are mandatory.
	 ECHO  * Parameters surrounded by [] are optional.
	 ECHO  * Options are case-insensitive, and can be prefaced by "-" or "/".
	 ECHO  * The default delay between STOP/START in a RESTART is 5 seconds.
 )
 CALL :ShowStatus "FINISHED"
                    