@REM - ASB (23 Sep 2010 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 13 Nov 2017 / 27 Mar 2016): Capture List of Running Services on System
@ECHO OFF
 CLS


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.7.0.090

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @FIRSTRUN=TRUE
 SET @CURRENT=%TEMP%\%~n0.Current.TXT
 SET @PREVIOUS=%TEMP%\%~n0.Before.TXT
 SET @COMPARE=%TEMP%\%~n0.Compare.TXT
 SET @TEMPLOG=%TEMP%\%~n0.TEMP.TXT


:Initialization
 ECHO [%DATE% at %TIME%] Capturing Service Status...  Please Wait...
 ECHO:
 ECHO Checking for Existing Logs...
 IF EXIST "%@CURRENT%" (
	 COPY "%@CURRENT%" "%@PREVIOUS%" /V
	 DEL "%@CURRENT%"
	 SET @FIRSTRUN=FALSE
 )


:Main
 IF EXIST "%@TEMPLOG%" DEL "%@TEMPLOG%"
 FOR /F "TOKENS=2" %%S IN ('PSSERVICE %@PSPARAMS% QUERY 2^>NUL ^| FIND /I "SERVICE_NAME"') DO (
	 FOR /F "TOKENS=4" %%V IN ('SC QUERY %%~S ^| FIND "STATE"') DO (
		 SET @SERVICE=%%~S                                            .
		 ECHO !@SERVICE:~0,30! is %%~V >>"%@TEMPLOG%"
	 )
 )


:Output
 ( rem -- Write to Log
	 TYPE "%@TEMPLOG%" | FIND "is RUNNING"
	 ECHO %@DIVIDER-%
	 TYPE "%@TEMPLOG%" | FIND /V "is RUNNING"
 ) >>"%@CURRENT%"

 IF "%@FIRSTRUN%"=="TRUE" (
	 ECHO [%DATE% at %TIME%] Capturing Service Status...
	 ECHO:
	 ECHO FIRST TIME EXECUTED: NO COMPARISON AVAILABLE...
	 ECHO:
	 ECHO:
 ) ELSE (
	 ECHO [%DATE% at %TIME%] Capturing Service Status...
	 FC /L "%@CURRENT%" "%@PREVIOUS%"
 ) >"%@COMPARE%"


:ExitBatch
 DIR "%@CURRENT%"
 ECHO:
 TYPE "%@COMPARE%"
 CALL :ShowStatus "FINISHED"
 ENDLOCAL


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                                                   