@ECHO OFF
 rem ==========================================================================
 rem === Defrag All Drives
 rem ==========================================================================
 rem
 rem Created On: 12 Jun 2003
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 07 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: Windows XP or Server 2003
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script defrags all local drives (which you can set with
 :::  an environment variable) using the native defrag utility.
 :::  The scheduled job is automatically created.
 :::
 :::  This script also logs the time that it took to run the defrag.
 :::
 :::  NOTE: It won't run properly if the Computer Management MMC
 :::  is already running.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Mar 2003
 rem ==========================================================================
:NeedHelp
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 07 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Calculate Date/Time (Short Procedure)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Job Scheduling Variables
 SET @JOBNAME=Daily Defrag
 SET @JOBPATH=%~f0
 SET @JOBFREQ=DAILY
 SET @JOBTIME=03:15:00
 SET @JOBUSER=NT AUTHORITY\SYSTEM

 rem -- Standard Variables
 SET @LOCALDRIVES=
 SET @LOGPATH=%@STORAGE%\Logs\Defrag
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Create Scheduled Job using SCHTASKS or AT
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:ScheduleJobs
 ECHO:
 ECHO Scheduling "%@JOBNAME%"...
 ECHO:

 IF EXIST "%SystemRoot%\System32\SCHTASKS.EXE" (
	 SCHTASKS /QUERY /V /FO LIST | FIND /I "%@JOBPATH%" >NUL
	 IF ERRORLEVEL 1 (
		 SCHTASKS /CREATE /TN "%@JOBNAME%" /TR "%@JOBPATH%" /SC "%@JOBFREQ%" /ST %@JOBTIME% /RU "%@JOBUSER%"
	 )
 ) ELSE (
	 AT | FIND /I "%@JOBPATH%" >NUL
	 IF ERRORLEVEL 1 AT %@JOBTIME% /EVERY:M,T,W,TH,F,SA,SU  "%@JOBPATH%"
 )

 rem -- If the only parameter is "." then exit as soon as the job is scheduled
 IF /I "%1"=="." GOTO :EOF


 rem ==========================================================================
 rem === Defrag Each Drive and Log Results
 rem === Last Modified On 30 Nov 2003
 rem ==========================================================================
:RunDefrag
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 CALL :GetTime @STIME
 ECHO *** Please Wait ***
 FOR /F "DELIMS=$" %%D IN ('SRVINFO -NS ^| FIND "$"') DO CALL :GetDrives %%D

 FOR %%V IN (%@LOCALDRIVES%) DO (
	  ECHO Defragging Drive %%V:
	  DEFRAG %%V: -V >>"%@LOGFILE%"
 )
 CALL :GetTime @ETIME


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 04 Dec 2003
 rem ==========================================================================
:ExitBatch
 ECHO:                                                       >>"%@LOGFILE%"
 ECHO ------------------------------------------------------ >>"%@LOGFILE%"
 ECHO  Defrag Started AT ...... %@STIME%                     >>"%@LOGFILE%"
 ECHO  Defrag Ended AT ........ %@ETIME%                     >>"%@LOGFILE%"

 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Store Current Date and Time in Variable
 rem === Last Modified On 07 Dec 2003
 rem ==========================================================================
:GetTime
 rem - %1 = Variable to Store Date/Time
 SET %~1=%TIME: =0% on %DATE%
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Generate List Of All Local Drives
 rem === Last Modified On 30 Nov 2003
 rem ==========================================================================
:GetDrives
 rem %1 = current drive letter
 SET @LOCALDRIVES=%@LOCALDRIVES% %1
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 19 Jun 2003
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for DEFRAGSYS.BAT
 ECHO:
 ECHO === DefragSys
 ECHO:
 ECHO Example: DefragSys
 ECHO:
