@ECHO OFF
 rem ==========================================================================
 rem === Delete Empty Folders (Reiterative Version)
 rem ==========================================================================
 rem
 rem Created On: 07 Dec 2000
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 07 Dec 2000
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required: NONE
 rem ==========================================================================

 :::  This script will delete folders which are empty. To avoid
 :::  having to run the script multiple times, it will check to
 :::  see if any folders were deleted during the current run, and
 :::  if so, it will run again until no folders are deleted.  If
 :::  no folder is provided as a paramter (e.g. DelEmpty C:\Junk)
 :::  then the variable @FOLDER will contain the default C:\TEMP
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/Scripts/?File=Scripting.BAT


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 07 Dec 2000
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @DELETE=FALSE
 SET @FOLDER=%*& IF "%~1"=="" SET @FOLDER=C:\TEMP
 IF EXIST "%@FOLDER%" GOTO :Main


 rem ==========================================================================
 rem === ERROR: Folder Not Found
 rem === Last Modified On 07 Dec 2000
 rem ==========================================================================
:Error
 ECHO:
 ECHO ERROR: The folder "%@FOLDER%" does not exist...
 ECHO:
 ECHO Script aborted...
 ECHO:
 GOTO :EOF


 rem ==========================================================================
 rem === Recurse Through All Folders Starting From @FOLDER
 rem === Last Modified On 07 Dec 2000
 rem ==========================================================================
:Main
 PUSHD "%@FOLDER%"
 FOR /R %%V IN (.) DO CALL :CheckFolder %%V
 POPD
 ECHO:
 IF /I "%@DELETE%"=="TRUE" GOTO :Variables
 ECHO:
 IF /I "%@DELETE%"=="FALSE" ECHO No Folders Were Empty...
 IF /I "%@DELETE%"=="TRUE"  ECHO Empty Folders Deleted...


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 07 Dec 2000
 rem ==========================================================================
:ExitBatch
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Find Empty Folders To Delete
 rem === Last Modified On 07 Dec 2000
 rem ==========================================================================
:CheckFolder
 rem %1 = Current Folder Name To Check
 SET @EMPTY=TRUE
 SET @CURRENT=%1
 SET @CURRENT=%@CURRENT:\.=%
 FOR /F %%E IN ('DIR /B /A "%@CURRENT%"') DO SET @EMPTY=FALSE
 IF /I "%@EMPTY%"=="FALSE" GOTO :EOF
 ECHO The following folder (%@CURRENT%) is EMPTY
 RD /Q "%@CURRENT%"
 SET @DELETE=TRUE
 GOTO :EOF
