@ECHO OFF
 rem ==========================================================================
 rem === Delete Old Files (NT4/ROBOCOPY Version)
 rem ==========================================================================
 rem
 rem Created On: 10 Oct 1998
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 04 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 (ONLY)
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This version uses ROBOCOPY and will only work on NT4. Some
 :::  changes to the command processor (CMD) were made under
 :::  Win2K, making that version somewhat more elegant and more
 :::  straightforward than this one.
 :::
 :::  Folder names containing spaces should be entered AT the
 :::  command line with a '+' character in place of each space.
 :::  They will be converted back to a spaces in the script.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~1"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 04 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Calculate Date/Time (Short Procedure - ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Standard Variables
 SET @FOLDER=%1
 SET @FOLDER=%@FOLDER:+= %
 SET @AGE=%2& IF /I "%2"=="" SET @AGE=30
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Recurse Through Subfolders And Delete Old Files
 rem === Last Modified On 04 Dec 2003
 rem ==========================================================================
:SetFolders
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Hunting Through "%@FOLDER%" And Subfolders For Old Files... >"%@LOGFILE%"
 ECHO:                                                          >>"%@LOGFILE%"
 ECHO:
 ECHO Hunting Through "%@FOLDER%" And Subfolders For Old Files...
 ECHO:
 FOR /F "TOKENS=*" %%D IN ('DIR /B /AD /S "%@FOLDER%"') DO CALL :FindFolder %%D
 CALL :FindFolder %@FOLDER%


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 04 Dec 2003
 rem ==========================================================================
:ExitBatch
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Recurse Through Subfolders
 rem === Last Modified On 27 Jun 2000
 rem ==========================================================================
:FindFolder
 rem %* = Complete Folder Name
 SET @DIR=%*
 ECHO:
 ECHO Removing Files From "%@DIR%" Older Than %@AGE% Day(s)...
 ECHO:
 ECHO Removing Files From "%@DIR%" Older Than %@AGE% Day(s)... >>"%@LOGFILE%"
 FOR /F "TOKENS=4" %%F IN ('ROBOCOPY "%@DIR%" C:\JUNK *.* /XX /MINAGE:%@AGE% /L ^| FINDSTR /I /C:"New File"') DO CALL :RemoveFiles %%F
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Remove Files That Are Over XX Days Old
 rem === Last Modified On 27 Jun 2000
 rem ==========================================================================
:RemoveFiles
 rem %* = Current Filename
 SET @FILE=%*
 ECHO:                               >>"%@LOGFILE%"
 ECHO -- Purging "%@DIR%\%@FILE%"...
 ECHO -- Purging "%@DIR%\%@FILE%"... >>"%@LOGFILE%"
 ATTRIB -R -S -H "%@DIR%\%@FILE%"
 DEL "%@DIR%\%@FILE%"                >>"%@LOGFILE%"
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 23 Aug 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for DELOLD.BAT
 ECHO:
 ECHO === DelOld {initial_dir} [age_of_files]
 ECHO:
 ECHO Example: DelOld C:\STORAGE 10
 ECHO          DelOld D:\HOME 90
 ECHO          DelOld E:\ARCHIVES
 ECHO          DelOld F:\OLD+ARCHIVES
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: Spaces in the Folder Name should
 ECHO       be represented by a '+' symbol.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
