@ECHO OFF
 rem ==========================================================================
 rem === Delete Old Files (Win2K/FORFILES Version)
 rem ==========================================================================
 rem
 rem Created On: 10 Oct 1998
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 05 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: Windows 2000 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This version will work on Win2K only.  The use of FORFILES
 :::  from the ResKit makes it much smaller and faster.
 :::
 :::  Win2K also supports passing long name parameters by
 :::  surrounding them with quotes. (NT4 does not support this
 :::  functionality.)  Thanks to Gerald Gaston for the idea.
 :::  This will require less grief for anyone who has folders
 :::  which contain weird characters (such as '+').
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~1"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 05 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Calculate Date/Time (Short Procedure - ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Standard Variables
 SET @FOLDER=%1
 SET @AGE=%2& IF /I "%2"=="" SET @AGE=30
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Recurse Through Subfolders And Delete Old Files
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:SetFolders
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Hunting Through %@FOLDER% And Subfolders For Old Files... >"%@LOGFILE%"
 ECHO:                                                        >>"%@LOGFILE%"
 ECHO:
 ECHO Hunting Through %@FOLDER% And Subfolders For Old Files...
 ECHO:
 FOR /F "TOKENS=*" %%D IN ('FORFILES -p%@FOLDER% -d-%@AGE% -s -c"CMD /C ECHO @PATH\@FILE"') DO CALL :RemoveFiles "%%D"


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 04 Dec 2003
 rem ==========================================================================
:ExitBatch
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Remove Files That Are Over XX Days Old
 rem === Last Modified On 18 Oct 2000
 rem ==========================================================================
:RemoveFiles
 rem %* = Current Filename
 ECHO:                 >>"%@LOGFILE%"
 ECHO -- Purging %*...
 ECHO -- Purging %*... >>"%@LOGFILE%"
 ATTRIB -R -S -H %*
 DEL %*                >>"%@LOGFILE%"
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 23 Aug 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for DELOLD.BAT
 ECHO:
 ECHO === DelOld {initial_dir} [age_of_files]
 ECHO:
 ECHO Example: DelOld "C:\STORAGE" 10
 ECHO          DelOld "D:\HOME" 90
 ECHO          DelOld "E:\ARCHIVES"
 ECHO          DelOld "F:\OLD ARCHIVES"
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: The folder names must be surrounded
 ECHO       by quotes, whether or not the names
 ECHO       contain spaces in them.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
