@REM - ASB (24 Feb 2015 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 27 Mar 2016 / 05 May 2015): Delete Old INPUT Files
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.6.0.160

 SET @SOURCE=%~d0\Scripts\Bat\Input
 SET @DRIVES=A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
 SET @CLOUDLOC=& FOR %%C IN ("Dropbox" "Box Sync" "OneDrive" "Google Drive") DO SET @CLOUDLOC=!@CLOUDLOC! "%%~C\Scripts" "Storage\%%~C\Scripts"
 SET @FOLDERS="Scripts" "Storage\Source" "Storage\Source_Scripts" "Storage\Scripts_Source" !@CLOUDLOC!
 SET @INPUTFILES=& FOR %%F IN ("%@SOURCE%\[*].TXT") DO SET @INPUTFILES=!@INPUTFILES! "%%~nxF"
 SET @INPUTFILES=!@INPUTFILES:[=!
 SET @INPUTFILES=!@INPUTFILES:]=!


 rem -- Cycle Through Local Drives
:Main
 FOR %%D IN (%@DRIVES%) DO IF EXIST "%%~D:\" (
	 FOR %%L IN (%@FOLDERS%) DO IF EXIST "%%~D:\%%~L" (
		 PUSHD "%%~D:\%%~L"
		 ECHO:
		 ECHO Searching in: "%%~D:\%%~L"
		 FOR /R %%T IN (.) DO (
			 SET @THISDIR=%%~T
			 SET @THISDIR=!@THISDIR:~0,-1!
			 FOR %%F IN (%@INPUTFILES%) DO IF EXIST "!@THISDIR!%%~F" (
				 ECHO:
				 ECHO  - Renaming "!@THISDIR!%%~F" to "[%%~nF].TXT" ...
				 IF EXIST "!@THISDIR![%%~nF].TXT" (
					 ECHO  --- "[%%~nF].TXT" Already Exists
				 ) ELSE (
					 RENAME "!@THISDIR!%%~F" "[%%~nF].TXT"
					 ECHO  --- Done...
				 )
				 IF EXIST "!@THISDIR!%%~F" (
					 DEL "!@THISDIR!%%~F"
					 ECHO  --- "%%~nF.TXT" Deleted...
				 )
			 )
		 )
		 POPD
	 )
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
             