@ECHO OFF
 rem ==========================================================================
 rem === Disable Browser Service On Remote Systems
 rem ==========================================================================
 rem
 rem Created On: 28 Feb 1998
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 05 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script uses SC from the ResKit to set the startup
 :::  parameters to Disabled, and then to stop the service if
 :::  it's running. It also uses NOW and TIMEOUT from the ResKit.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 05 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Calculate Date/Time (Short Procedure - ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Standard Variables
 SET @SERVICE=BROWSER
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Check for Parameters
 rem === Last Modified On 15 Mar 2001
 rem ==========================================================================
:CheckParams
 IF /I NOT "%1"=="" GOTO :Disable
 ECHO *** No Parameters ***
 TIMEOUT 30
 GOTO :EOF


 rem ==========================================================================
 rem === Disable Designated Service and Stop It
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:Disable
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Disabling the "%@SERVICE%" service on "%1" >>"%@LOGFILE%"
 SC \\%1 QC %@SERVICE%
 SC \\%1 CONFIG %@SERVICE% START= disabled
 SC \\%1 STOP %@SERVICE%
 SC \\%1 QC %@SERVICE%


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 04 Dec 2003
 rem ==========================================================================
:ExitBatch
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
