 rem - ASB (26 Feb 2006 / 08 Jan 2007 / 31 Mar 2006): Get Exchange Info for Group of Exchange Servers
@ECHO OFF
 CLS

:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION
 SET @VER=%~nx0 v1.5.2

 rem -- Calculate Date/Time (Short Procedure - No ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=1-3 DELIMS=:. " %%T IN ('ECHO %TIME: =0%') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG
 SET @TIMESTAMP=%DATE% at %TIME%

 rem -- Get Official Drive Letters and Calculate Date/Time for NON-US Regions
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Standard Script Variables
 SET @SOURCE=%~1& IF "%~1"=="" SET @SOURCE=%~dp0Input\ExchangeList.TXT
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%
 SET @EVENTS=529^,538^,539^,540^,680^,681


 rem -- Create Logfile
:Main
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"
 ( rem -- Consolidate LogFile Output
	 ECHO Exchange Server System Info - %@TIMESTAMP%
	 ECHO ---------------------------------------------------------------------------
	 ECHO:
 ) >%@LOGFILE% 2>&1


 rem - Get Time-Related Info About The Exchange Servers
:GetTime
 FOR /F %%V IN (%@SOURCE%) DO ( rem -- Consolidate LogFile Output
	 ECHO Getting Remote Time Info on %%V >CON
	 NET TIME %%V | FIND /I "current time"
 ) >>%@LOGFILE% 2>&1

 FOR /F %%V IN (%@SOURCE%) DO ( rem -- Consolidate LogFile Output
	 ECHO Getting Local Time Info on %%V >CON
	 NET TIME %%V | FIND /I "local time"
 ) >>%@LOGFILE% 2>&1

 rem - Get Other System-Related Info About The Exchange Servers
:GetInfo
 FOR /F %%V IN (%@SOURCE%) DO ( rem -- Consolidate LogFile Output
	 ECHO:
	 ECHO Getting Service Info on %%V
	 ECHO:
	 ECHO ---------------------------------------------------------------------------
	 PSINFO %%V | FIND ":"
	 ECHO:
	 FILEVER %%V\ADMIN$\SYSTEM32\W32*.EXE
	 ECHO:
	 DIR %%V\ADMIN$\System32\W32T*.EXE /A
	 ECHO:
	 FOR /F "TOKENS=5* DELIMS=," %%S IN ('PSLOGLIST %%V -I "%@EVENTS%" -D 1 -S SECURITY ^| FIND /I "FAILURE"') DO ECHO %%S %%T
 ) >>%@LOGFILE% 2>&1


 rem - Reset Variables and Exit Batch File
:ExitBatch
 ECHO %@VER% - Completed Script
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
