@REM - ASB (07 Oct 2009 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 13 Nov 2017 / 27 Mar 2016): Delete Cloned Registry Keys for WSUS Config
@ECHO OFF
 CLS


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v2.6.0.160

 SET @LIST=%~1& IF "%~1"=="" SET @LIST=%SystemDrive%\Scripts\Bat\Input\FixWSUS.TXT
 SET @SETREG=FALSE& FOR %%P IN (%*) DO IF "%%~P"=="." SET @SETREG=TRUE
 SET @PSPARAMS=-AcceptEula -NoBanner


 rem -- Query and/or Set WSUS Registry Items
:Main
 FOR /F %%V IN (%@LIST%) DO (
	 SET @MACHINE=%%~V
	 SET @MACHINE=\\!@MACHINE:\=!
	 ECHO:
	 ECHO:
	 ECHO Changing Settings on !@MACHINE!...
	 IF /I "%@SETREG%"=="TRUE" PSSERVICE %@PSPARAMS% !@MACHINE! STOP WUAUSERV
	 REG QUERY "!@MACHINE!\HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /s | FIND /I "SUSCLIENT"
	 IF /I "%@SETREG%"=="TRUE" REG DELETE "!@MACHINE!\HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v AccountDomainSid /f
	 IF /I "%@SETREG%"=="TRUE" REG DELETE "!@MACHINE!\HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v PingID /f
	 IF /I "%@SETREG%"=="TRUE" REG DELETE "!@MACHINE!\HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v SusClientId /f
	 IF /I "%@SETREG%"=="TRUE" PSSERVICE %@PSPARAMS% !@MACHINE! START WUAUSERV
	 IF /I "%@SETREG%"=="TRUE" PSEXEC %@PSPARAMS% !@MACHINE! wuauclt /resetauthorization /detectnow
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
    