@REM - ASB (15 Dec 2019 / 22 Jan 2020 / 15 Dec 2019 / 15 Dec 2019): Obtain CPU Info via WMIC
@ECHO OFF


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION
 SET @ITEMS=Manufacturer, Name, SocketDesignation, Description, Revision, CurrentClockSpeed, MaxClockSpeed
 CALL :PadRight @DIV "" "-" 79


 rem -- Obtain CPU Info via WMIC
:Main
 ECHO %@DIV%
 ECHO --- CPU INFO
 ECHO %@DIV%
 FOR /F "TOKENS=1* DELIMS==" %%V IN ('WMIC CPU LIST FULL /FORMAT:LIST') DO SET #%%~V=%%~W
 FOR %%V IN (%@ITEMS%) DO (
	 CALL :PadRight @%%~V "%%~V " "." 22
	 ECHO !@%%~V! !#%%~V!
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Pad Variable Content to the Left/Right for Display in Logs
:PadLeft
:PadRight
 rem %1 = Variable to Store New Content
 rem %2 = Existing Value to Pad
 rem %3 = Character to use as padding [typically " ", "." or "0"]
 rem %4 = New String Length

 SET @STR=%~2
 SET @LEN=& FOR /L %%c IN (0,1,199) DO IF "!@STR:~%%c,1!"=="" IF NOT DEFINED @LEN SET @LEN=%%c
 IF 1%@LEN% GEQ 1%~4 (
	 SET %~1=%~2
 ) ELSE (
	 IF /I "%~0"==":PadLeft" (
		 SET @TEMPVAR=& FOR /L %%c IN (1,1,%~4) DO SET @TEMPVAR=!@TEMPVAR!%~3
		 SET @TEMPVAR=!@TEMPVAR!%~2
		 SET %~1=!@TEMPVAR:~-%~4!
	 )
	 IF /I "%~0"==":PadRight" (
		 SET @TEMPVAR=%~2& FOR /L %%c IN (1,1,%~4) DO SET @TEMPVAR=!@TEMPVAR!%~3
		 SET %~1=!@TEMPVAR:~0,%~4!
	 )
 )
 %@PAUSE_IF_DEBUG%
 GOTO :EOF
     