@REM - ASB (25 Apr 2013 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 27 Mar 2016): Generate List of Suspect Services from GetInfo.BAT Results
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.6.0.160

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @MSG=Generating Suspect Service List
 SET @FILES=\Storage\Logs\Forensics\*SUS*.TXT
 SET @DRIVES=C D E F
 SET @OUTPUT=%TEMP%\SuspectList.%@FILESTAMP_R%


 rem -- Generate Concatenated List
:Main
 IF EXIST "%@OUTPUT%.TMP" DEL "%@OUTPUT%.TMP" >NUL
 ECHO ;%@MSG% @ %DATE% at %TIME% >"%@OUTPUT%"

 ECHO %@MSG%...
 ECHO:
 FOR %%V IN (%@DRIVES%) DO IF EXIST "%%V:%@FILES%" TYPE "%%V:%@FILES%" >>"%@OUTPUT%.TMP" 2>NUL
 FOR /F "TOKENS=*" %%P IN ('SORT "%@OUTPUT%.TMP"') DO (
	 SET @LINE=%%P
	 SET @LINE=!@LINE:-- Suspect Service? =!
	 SET @LINE=!@LINE:??=!
	 ECHO !@LINE! >>"%@OUTPUT%"
 )


 rem -- Log Maintenance and Final Report
:LogMaint
 IF EXIST "%@OUTPUT%.TMP" DEL "%@OUTPUT%.TMP" >NUL
 TYPE "%@OUTPUT%" & ECHO: & DIR "%@OUTPUT%"
 ECHO To Copy Data, Type: NOTEPAD "%@OUTPUT%"


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                                       