@ECHO OFF
 rem ==========================================================================
 rem === Determine/Compare Version of Executable File
 rem ==========================================================================
 rem
 rem Created On: 10 Jul 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Sep 2001
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script uses FILEVER to determine the version info of
 :::  a local executable or DLL, and gives you the ability to
 :::  compare the version to a specific one AT the command line.
 :::  This is useful for logon scripts, and could be used to
 :::  update the appropriate files or utilities.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~1"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @EXE=%~1
 SET @VERSION=%2
 IF /I NOT "%2"=="" SET @COMPARE=^| FIND /I "ERROR:"
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Cycle Through Domain (or File List) And Get Version Info
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:GetComputers
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Obtaining Version Info For "%@EXE%" on %COMPUTERNAME%... >"%@LOGFILE%"
 ECHO Obtaining Version Info For "%@EXE%" on %COMPUTERNAME%...
 IF NOT EXIST "%@EXE%" ECHO ERROR: The File "%@EXE%" Does Not Exist >>"%@LOGFILE%"

 IF EXIST "%@EXE%" (
   FILEVER "%@EXE%" >>"%@LOGFILE%"
   IF /I NOT "%@VERSION%"=="" (
     FILEVER "%@EXE%" | FIND /I "%@VERSION%" >NUL
     IF ERRORLEVEL 1 ECHO ERROR: "%@EXE%" Doesn't Match Version "%@VERSION%" >>"%@LOGFILE%"
   )
   ECHO: >>"%@LOGFILE%"
 )
 ECHO Finished Obtaining Version Info For "%@EXE%" on %COMPUTERNAME%...
 ECHO:
 TYPE "%@LOGFILE%" %@COMPARE%
 GOTO :EOF


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 27 Jun 2000
 rem ==========================================================================
:ExitBatch
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 10 Jul 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for GETVERSION.BAT
 ECHO:
 ECHO === GetVersion {Full_Path_Of_Executable} [Version_To_Compare]
 ECHO:
 ECHO Example: GetVersion %SystemRoot%\ThisFile.exe
 ECHO          GetVersion %SystemRoot%\Explorer.exe 5.0.3315.2846
 ECHO          GetVersion "D:\Long Path Name\Filename.exe" 2.0
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: Folder names which contain spaces
 ECHO       should be surrounded by quotes.
 ECHO       Shortnames *can* be surrounded by
 ECHO       quotes if you choose, but it is not
 ECHO       mandatory by any means.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
