@ECHO OFF
 rem ==========================================================================
 rem === Determine/Compare Version of Remote Executable Files
 rem ==========================================================================
 rem
 rem Created On: 10 Jul 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Sep 2001
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script uses FILEVER to determine the version info of
 :::  a remote executable or DLL, and gives you the ability to
 :::  compare the version to a specific one AT the command line.
 :::  A report will be generated of the version for all systems.
 :::  If any version info is requested AT the command line, the
 :::  script will also display the names of systems that didn't
 :::  match the version criteria.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~1"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @EXE=%~1
 SET @VERSION=%2
 IF /I NOT "%2"=="" SET @COMPARE=^| FIND /I "ERROR:"
 SET @COMPLIST='NET VIEW'
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Cycle Through Domain (or File List) And Get Version Info
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:GetComputers
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Determining Version Info For "%@EXE%"... >"%@LOGFILE%"
 ECHO Getting a List of Computers via "%@COMPLIST%"...
 ECHO:
 ECHO Determining Version Info For "%@EXE%"...
 FOR /F %%V IN (%@COMPLIST%) DO CALL :GetVerInfo %%V
 ECHO Finished Determining Version Info For "%@EXE%"...
 ECHO:
 TYPE "%@LOGFILE%" %@COMPARE%
 GOTO :EOF


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 10 Jul 2001
 rem ==========================================================================
:ExitBatch
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Determine Version Info For Each Machine
 rem === Last Modified On 10 Jul 2001
 rem ==========================================================================
:GetVerInfo
 rem %1 = Current System To Be Checked
 SET @PARAM=%1
 IF /I NOT "%@PARAM:~0,2%"=="\\" GOTO :EOF
 ECHO Getting Info For "%1\%@EXE%"...
 ECHO Getting Info For "%1\%@EXE%"... >>"%@LOGFILE%"
 IF NOT EXIST "%1\%@EXE%" ECHO ERROR: Cannot Access "%1\%@EXE%" >>"%@LOGFILE%"

 IF EXIST "%1\%@EXE%" (
   FILEVER "%1\%@EXE%" >>"%@LOGFILE%"
   IF /I NOT "%@VERSION%"=="" (
     FILEVER "%1\%@EXE%" | FIND /I "%@VERSION%" >NUL
     IF ERRORLEVEL 1 ECHO ERROR: "%1\%@EXE%" Doesn't Match Version "%@VERSION%" >>"%@LOGFILE%"
   )
   ECHO: >>"%@LOGFILE%"
 )
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 23 Aug 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for GETVERSION.BAT
 ECHO:
 ECHO === GetVersion {Remote_Sharename_And_Path_Of_Executable} [Version_To_Compare]
 ECHO:
 ECHO Example: GetVersion ADMIN$\ThisFile.exe
 ECHO          GetVersion ADMIN$\Explorer.exe 5.0.3315.2846
 ECHO          GetVersion "D$\Long Folder Name\Filename.exe" 2.0
 ECHO          GetVersion "Sharename\Other Folder Name\Filename.exe" 4.0.1
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: Folder names which contain spaces should be
 ECHO       surrounded by quotes. Shortnames *can* be
 ECHO       surrounded by quotes if you choose, but it
 ECHO       is not mandatory by any means.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
