@ECHO OFF
 rem ==========================================================================
 rem === Enumerate All Nested Users of Local Groups
 rem ==========================================================================
 rem
 rem Created On: 15 Aug 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Sep 2001
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script takes a Local Group (Domain or Machine) as its
 :::  parameter, and generates a list containing all the the user
 :::  accounts that are members of that group.  Under Win2K the
 :::  output is a little weird if you reference the local machine
 :::  accounts.  Usernames will appear once for each group
 :::  membership that exists.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~2"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @GROUP=%~1
 SET @DOMAIN=%~2
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Enumerate Groups and Users
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:GetGroups
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 ECHO Obtaining Member List For The Following Local Group...
 ECHO - Group ....................: %@GROUP%
 ECHO - Domain/Computer ..........: %@DOMAIN%
 ECHO:
 ECHO: >"%@LOGFILE%"
 FOR /F "TOKENS=1 DELIMS=:" %%V IN ('LOCAL "%@GROUP%" %@DOMAIN%') DO IF /I "%%V"=="GetUsers - Unknown Error" (
   ECHO Domain or Group Name is Invalid... >>"%@LOGFILE%"
   ECHO Domain or Group Name is Invalid...
   GOTO :ExitBatch
 )

 FOR /F "TOKENS=1-2 DELIMS=\" %%V IN ('LOCAL "%@GROUP%" %@DOMAIN%') DO CALL :GetUsers "%%W" %%V
 NOW Obtaining Member List For '%@DOMAIN%\%@GROUP%' >>"%@LOGFILE%"
 SORT /r "%@LOGFILE%"


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 15 Aug 2001
 rem ==========================================================================
:ExitBatch
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Enumerate User Accounts
 rem === Last Modified On 15 Aug 2001
 rem ==========================================================================
:GetUsers
 rem %1 = Group
 rem %2 = Domain
 FOR /F %%V IN ('GLOBAL "%~1" %2 ^| FIND /I /V "group not found"') DO ECHO "%2\%%V" >>"%@LOGFILE%"
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 23 Aug 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for GROUPMEM.BAT
 ECHO:
 ECHO === GroupMem {local_group} {\\server OR domain}
 ECHO:
 ECHO Example: GroupMem Administrators MyDomain
 ECHO          GroupMem Administrators \\MyComputer
 ECHO          GroupMem Users \\%COMPUTERNAME%
 ECHO          GroupMem "Special Group" OtherDomain
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: Folder names containing spaces should
 ECHO       be surrounded by quotation marks.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
