@REM - ASB (10 Nov 2013 // 16 Oct 2023 / 13 Jul 2020 / 12 Jun 2020 / 24 Dec 2019 / 30 Sep 2019 / 19 May 2019 / 26 Feb 2019 / 29 Apr 2018 / 05 May 2015): Install a Remote Executable by Copying Locally First
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.9.0.190

 SET @SOURCE=%~1& IF DEFINED @SOURCE SET @SOURCE=!@SOURCE:S:\=\\ARIES\Storage\Files\Downloads\!
 SET @SOURCE=!@SOURCE:\Downloads\Downloads\=\Downloads\!
 SET @LOCALAPP=%TEMP%\%~nx1


 rem -- Determine If Source File Exists
:VerifySource
 IF NOT EXIST "%@SOURCE%" (
	 ECHO *** Could Not Find the Following File ***
	 ECHO "%@SOURCE%"
	 DIR "%@SOURCE%"
	 GOTO :ExitBatch
 )


 rem -- Set Appropriate PATH and call Application
:Main
 ECHO Copying and Installing the following application:
 ECHO  SOURCE FOLDER ..... !@SOURCE:%~nx1=!
 ECHO  SOURCE NAME ....... %~nx1
 ECHO:

 rem -- Confirm Installation
 CHOICE /C YNQEX /T 10 /D Y /N /M "Continue with Installation? (Y/N) "
 IF !ERRORLEVEL! GEQ 2 (
	 ECHO:
	 ECHO Installation Aborted...
	 GOTO :ExitBatch
 )

 rem -- Install File
 ECHO Copying Installation File...
 COPY "%@SOURCE%" "%TEMP%" /Y
 IF EXIST "%@LOCALAPP%" (
	 ECHO Running Installation File...
	 "%@LOCALAPP%"
	 ECHO Deleting Temp Files...
	 IF EXIST "%@LOCALAPP%" DEL "%@LOCALAPP%"
 ) ELSE (
	 ECHO Could Not Copy "%@LOCALAPP%"
	 GOTO :ExitBatch
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                             