@ECHO OFF
 rem ==========================================================================
 rem === Install Latest NT4 Service Pack (Currently SP6a)
 rem ==========================================================================
 rem
 rem Created On: 10 Oct 1998
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script will backup the current Service Pack Uninstall
 :::  folders, prior to installing the latest SP from a network
 :::  location.  This will allow you to uninstall as many SP
 :::  installations as you have room to keep.  It was originally
 :::  created for NT4, but should work in Windows 2000.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:Variables
 IF /I "%DEBUG%"=="TRUE" ECHO ON
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Calculate Date/Time (Short Procedure - ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Standard Variables
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%

 SET @CMDLINE=(%CMDCMDLINE%) %0 %*
 SET @SP_LOC=\\FileServer\ServicePack
 SET @SYMBOLS_LOC=%@SP_LOC%\Symbols
 SET @UNINSTALL=%SystemRoot%\$NtServicePackUninstall$
:Variables
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 5


 rem ==========================================================================
 rem === Allow User To Abort Operation
 rem === Last Modified On 19 Nov 1999
 rem ==========================================================================
:DblCheck
 FOR %%P IN (%*) DO IF "%%P"=="." GOTO :DblCheck
 CLS
 ECHO === Prepare to Install Latest Service Pack ===
 ECHO:
 ECHO Press [CTRL-C] To Abort, Any Other Key To Continue...
 ECHO:
 TIMEOUT 20
:DblCheck
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 5


 rem ==========================================================================
 rem === Copying Updated Debug Symbols...
 rem === Last Modified On 23 Nov 1999
 rem ==========================================================================
:Symbols
 ECHO:
 ECHO Copying Updated Debug Symbols...
 ECHO:
 XCOPY "%@SYMBOLS_LOC%\*.*" "%SystemRoot%\Symbols" /S /E /I /C /V /D /R /K /H /F
:Symbols
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 5


 rem ==========================================================================
 rem === Log Pertinent Info (If Any)
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:DebugLog
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW %@CMDLINE%   >>"%@LOGFILE%"
 SET              >>"%@LOGFILE%"
 ECHO:            >>"%@LOGFILE%"
:DebugLog
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 5


 rem ==========================================================================
 rem === Backup Old Uninstall Folder
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:Backup
 IF NOT EXIST "%@UNINSTALL%" GOTO :Backup
 ECHO:
 ECHO Making Backup of Uninstall Folder...
 ECHO:
 ATTRIB -H "%@UNINSTALL%"
 REN "%@UNINSTALL%" "$NtServicePackUninstall$.%@FILESTAMP%"
 ATTRIB +H "%@UNINSTALL%.%@FILESTAMP%"
:Backup
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 5


 rem ==========================================================================
 rem === Install Latest Service Pack
 rem === Last Modified On 16 Nov 1999
 rem ==========================================================================
:ServicePack
 ECHO:
 ECHO Installing Latest Service Pack...
 ECHO:
 %@SP_LOC%\UPDATE.EXE -u -f -o
:ServicePack
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 5


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:ExitBatch
 ECHO:
 ECHO FINISHED Installing Latest Service Pack!
 ECHO:
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 IF /I "%DEBUG%"=="TRUE" TIMEOUT 20
 ENDLOCAL
