@ECHO OFF
 rem ==========================================================================
 rem === Determine Local Hard Drives On System
 rem ==========================================================================
 rem
 rem Created On: 24 Mar 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	PSTOOLS ................ http://www.sysinternals.com/Utilities/PsTools.html
 rem ==========================================================================

 :::  This script uses PSINFO to find the drive letters, which are
 :::  then stored in the @LOCALDRVS variable.
 :::
 :::  This script is best used as a part of a larger script that
 :::  needs to act on local hard drives, such as a disk cleanup
 :::  script.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Find Local Drives
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:FindDrives
 SETLOCAL
 FOR /F %%V IN ('PSINFO -D ^| FIND "Fixed"') DO CALL :BuildVar %%V
 ECHO %@LOCALDRVS%
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Build Variable with Local Drive Letters
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:BuildVar
 rem %1 = Drive Letter To Add To List
 SET @LOCALDRVS=%@LOCALDRVS% %1
 GOTO :EOF
