@ECHO OFF
 rem ==========================================================================
 rem === Generic Logon Script (Windows 2000, XP and higher)
 rem ==========================================================================
 rem
 rem Created On: 26 Mar 2003
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 15 Jul 2004
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: 2000/2003 Servers; 2000/XP/2003 Clients
 rem
 rem  Non-Native Utilities Required:
 rem  	PSTOOLS ................ http://www.sysinternals.com/Utilities/PsTools.html
 rem  	Resource Kit ........... http://KB.UltraTech-llc.com/?File=ResKit.TXT
 rem  	Event-to-SysLog ........ http://KB.UltraTech-llc.com/?File=EventLog.TXT
 rem ==========================================================================

 :::  This is a generic logon script which maps drives based on
 :::  domain group membership.  You can make it do lots of other
 :::  things.  Lots of ResKit utilities, including Kixtart, are
 :::  used to compile some system info which will allow you to
 :::  more quickly resolve client-side issues.  This info is
 :::  copied to a centralized network share.
 :::
 :::  This script allows you to update scripts and utilities on
 :::  on your client machines, as well as installing an EventLog
 :::  to SysLog tool.
 :::
 :::  Be sure to add all of the files/folders into the appropriate
 :::  GPO folder in order to have them copied to your client
 :::  systems.
 :::
 :::  Example:
 :::        -- Logon.BAT
 :::        ----- Scripts\Util1.bat
 :::        ----- Scripts\Util2.exe
 :::        ----- Scripts\Util3.exe
 :::        ----- System32\File1.bat
 :::        ----- System32\File2.exe
 :::        ----- System32\File3.sys
 :::
 :::  This script has been modified to support 2000/XP clients
 :::  only.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.UltraTech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Set Environment Variables
 rem === Last Modified On 15 Jul 2004
 rem ==========================================================================
:Variables
 SET @ACCOUNTS=Administrator ServiceAcct
 SET @SERVERS=SERVER1 SERVER2 SERVER3 SERVER4
 SET @DOMAIN=%USERDOMAIN%
 SET @FILESERVER=\\MyFILESERVER
 SET @RESERVED=%HOMEDRIVE% V: W: X: Y: Z:
 SET @SYSLOG=syslog.mydomain.local
 SET @LOGPATH=%SystemDrive%\Storage\LogonData
 SET @NETLOG=%@FILESERVER%\LogonData$

 SET @SOURCE1=%~dp0Scripts
 SET @SOURCE2=%~dp0System32
 SET @DEST1=%SystemDrive%\Scripts
 SET @DEST2=%SystemRoot%\System32


 rem ==========================================================================
 rem === Update Scripts and Utilities
 rem === Last Modified On 23 Nov 2003
 rem ==========================================================================
:UpdateScripts
 ECHO:
 ECHO Updating System Scripts...
 ECHO:
 XCOPY "%@SOURCE1%" "%@DEST1%" /S /E /C /I /D /F /H /K /Y
 XCOPY "%@SOURCE2%" "%@DEST2%" /S /E /C /I /D /F /H /K /Y
 NET START | FIND /I "EventLog to SysLog" >NUL
 IF ERRORLEVEL 1 %@DEST2%\evtsys -i -h %@SYSLOG%
 NET START EVTSYS


 rem ==========================================================================
 rem === Map Shares (except for H:, the Home Drive)
 rem === Last Modified On 26 Nov 2003
 rem ==========================================================================
:MapShares
 FOR %%V IN (%@ACCOUNTS%) DO IF /I "%USERNAME%"=="%%V" GOTO :CreateLogs
 FOR %%V IN (%@SERVERS%) DO IF /I "%COMPUTERNAME%"=="%%V" GOTO :CreateLogs
 ECHO:
 ECHO Mapping Server Shares...
 ECHO:
 FOR /F "TOKENS=2" %%V IN ('NET USE ^| FIND ":"') DO CALL :EraseMappings %%V

 rem -- Default Mappings
 CALL :MapGroup "Domain Users"   S: "%@FILESERVER%\Downloads"
 CALL :MapGroup "Domain Users"   T: "%@FILESERVER%\Installs"

 rem -- Mappings based on Group Membership
 CALL :MapGroup "Domain Admins"  S: "%@FILESERVER%\Downloads$"
 CALL :MapGroup "Domain Admins"  Q: "%@FILESERVER%\Special Share"
 CALL :MapGroup "Domain Admins"  R: "%@FILESERVER%\Other Share$"


 rem ==========================================================================
 rem === Create System Diagnostics Log For Debug Purposes
 rem === Last Modified On 26 Nov 2003
 rem ==========================================================================
:CreateLogs
 ECHO:
 ECHO Generating Logon Diagnostics Log... (Please Wait)
 ECHO:
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%" >NUL
 KIX32 "%~dp0Configure.KIX"
 KIX32 "%~dp0LogonInfo.KIX"
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 FINDGRP %USERDOMAIN% %USERDOMAIN%\%USERNAME%                  >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 FINDGRP \\%COMPUTERNAME% %USERDOMAIN%\%USERNAME%              >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 SHOWGRPS | FIND "User:" /I                                    >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 SHOWGRPS | FIND "User:" /I /V | FIND "\" | SORT               >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 NET USE                                                       >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 SRVINFO -ns                                                   >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 PSINFO -d                                                     >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 NET START                                                     >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 NET SHARE                                                     >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 NET USER                                                      >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO ******************************************************** >>"%@LOGPATH%\LMScript.LOG" 2>&1
 DIR "%~dp0" /OGN                                              >>"%@LOGPATH%\LMScript.LOG" 2>&1
 DIR %@DEST1%\BAT /OGN                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 DIR %@DEST1%\UTILS /OGN                                       >>"%@LOGPATH%\LMScript.LOG" 2>&1
 DIR %@DEST2%\EVTSYS.*                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 DIR %@LOGPATH%                                                >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO:                                                         >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO Current Environment Variables                            >>"%@LOGPATH%\LMScript.LOG" 2>&1
 ECHO *****************************                            >>"%@LOGPATH%\LMScript.LOG" 2>&1
 SET                                                           >>"%@LOGPATH%\LMScript.LOG" 2>&1
 NOW System Diagnostics Log Completed                          >>"%@LOGPATH%\LMScript.LOG" 2>&1
 NOW '%USERNAME%' Has Completed Logon Script on %COMPUTERNAME% >>"%@LOGPATH%\LMScript.TXT" 2>&1
 COPY "%@LOGPATH%\LMScript.*" "%@NETLOG%\%COMPUTERNAME%.*"       >NUL
 ATTRIB +H "%@LOGPATH%" >NUL


 rem ==========================================================================
 rem === Exit Batch File
 rem === Last Modified On 23 Nov 2003
 rem ==========================================================================
:ExitBatch
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Map Shares Based On Group Membership
 rem === Last Modified On 27 Mar 2003
 rem ==========================================================================
:MapGroup
 rem %1 = Group Membership to Check For
 rem %2 = Drive Letter To Use For Mapping
 rem %3 = Remote Resource To Map

 SET @GROUP=%@DOMAIN%\%~1
 SET @DRIVE=%2
 SET @SHARE=%~3
 IFMEMBER "%@GROUP%"
 IF ERRORLEVEL 1 (
   NET USE %@DRIVE% /D /Y  >NUL
   NET USE %@DRIVE% "%@SHARE%" /Y  >NUL
 )
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Erase All Existing Mappings Except U-Z
 rem === Last Modified On 14 Mar 2004
 rem ==========================================================================
:EraseMappings
 rem %1 = Current Drive Letter
 FOR %%D IN (%@RESERVED%) DO IF /I "%1"=="%%D" GOTO :EOF
 NET USE %1 /D /Y
 GOTO :EOF


 rem ==========================================================================
 rem === Quick Exit Location for Legacy (Win9x) Clients
 rem === Last Modified On 26 Mar 2003
 rem ==========================================================================
:Finish
