@REM - ASB (09 Oct 2013 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 26 Jun 2019 / 29 Apr 2018 / 27 Mar 2016 / 05 May 2015): Delete Old Default Route and Establish New One
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.7.0.170

 SET @ALIVE=FALSE
 SET @GATEWAY=%~1
 IF NOT DEFINED @GATEWAY IF DEFINED @DEFAULTGATEWAY (SET @GATEWAY=%@DEFAULTGATEWAY%) ELSE (SET @GATEWAY=172.30.2.3)
 SET @PERM=-P& IF "%~2"=="" SET @PERM=


 rem -- Request Gateway Change
:RequestChange
 CHOICE /C YNQEX /T 10 /D Y /N /M "Setting New Default Gateway to %@GATEWAY%? (Y/N)"
 IF !ERRORLEVEL! GTR 1 (
	 ECHO:
	 ECHO *** Change to Default Route Aborted ***
	 ECHO:
	 GOTO :ExitBatch
 )


 rem -- Verify IP Address
:CheckGateway
 ECHO:
 ECHO Trying to Verify New Gateway [%@GATEWAY%]...
 FOR /F "TOKENS=*" %%P IN ('PING %@GATEWAY% ^| FINDSTR /I "time= time<"') DO SET @ALIVE=TRUE
 IF "%@ALIVE%"=="FALSE" (
	 ECHO:
	 ECHO *** Could Not Reach "%@GATEWAY%". Change to Default Route Aborted ***
	 GOTO :ExitBatch
 )


 rem -- Set New Gateway
:SetGateway
 ECHO:
 ECHO New Gateway Verified.  Change in Progress...
 ROUTE %@PERM% DELETE 0.0.0.0
 ROUTE %@PERM% ADD 0.0.0.0 MASK 0.0.0.0 %@GATEWAY%
 TIMEOUT 5
 ROUTE -P PRINT


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                     