@REM - ASB (23 Feb 2006 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 25 Mar 2015 / 22 Feb 2015): Set User Accounts to Expire
@ECHO OFF
 CLS


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.9.0.190

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @DOMAIN=%~1& IF "%~1"=="" SET @DOMAIN=%USERDOMAIN%
 SET @SOURCE=%~2& IF "%~2"=="" SET @SOURCE=UserAccounts.TXT
 SET @LOGFILE=%TEMP%\%~n0.%@FILESTAMP%

 rem - Get DC NameAllow User Accounts in List to Expire
 ECHO ON
 FOR /F "TOKENS=2" %%D IN ('NETPWAGE /USERS /DOMAIN:%@DOMAIN% ^| FIND "\\"') DO SET @DC=%%D
 IF /I "%@DC%"=="" (
	 ECHO No Valid Domain Controller for %@DOMAIN%
	 GOTO :ExitBatch
 )


 rem - Allow User Accounts in List to Expire
:RemoveException
 ECHO Clear Expiration on %@TODAY%-%@NOW% >"%@LOGFILE%"
 ECHO:                                   >>"%@LOGFILE%"

 FOR /F "TOKENS=*" %%V IN (%@SOURCE%) DO (
	 ECHO Removing Password Expiration for: "%%V"
	 ECHO Removing Password Expiration for: "%%V"          >>"%@LOGFILE%" 2>&1
	 CUSRMGR -u "%%V" -s PasswordNeverExpires -m %@DOMAIN% >NUL
   PSEXEC %@PSPARAMS% %@DC% NET USER "%%V"               >>"%@LOGFILE%" 2>&1
 )


 rem - Reset Variables and Exit Batch File
:ExitBatch
 START "%@LOGFILE%" "%@LOGFILE%" & DIR "%@LOGFILE%"
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                     