@REM - ASB (06 Feb 2014 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 27 Mar 2016 / 05 May 2015): Disable StealthMode in Windows Firewall
@ECHO OFF
 CLS


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.5.0.150

 SET @FW_PROFILES=Domain Private Public Standard
 SET @FW_KEY=HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\WindowsFirewall
 SET @FW_VAL=DisableStealthMode
 SET @CONNECT=\\%~1&  IF "%~1"=="" SET @CONNECT=%COMPUTERNAME%
 SET @CONNECT=\\%@CONNECT:\\=%


 rem -- Set/View the DisableStealthMode Entry for Windows Firewall
:Main
 FOR %%p IN (%@FW_PROFILES%) DO (
	 SET @OUTPUT=No Entry Found  [Default = StealthMode Enabled]
	 ECHO:
	 ECHO Searching for StealthMode Setting in the %%~p Profile on %@CONNECT% ...
	 FOR /F "TOKENS=*" %%R IN ('REG QUERY "%@CONNECT%\%@FW_KEY%\%%~pProfile" ^| FIND /I "%@FW_VAL%"') DO SET @OUTPUT=%%R
	 ECHO  -- !@OUTPUT!

	 IF NOT "%~2"=="" (
		 ECHO:
		 ECHO Disabling Windows Firewall StealthMode in the %%~p Profile on %@CONNECT% ...
		 REG ADD "%@CONNECT%\%@FW_KEY%\%%~pProfile" /v "%@FW_VAL%" /t REG_DWORD /d "1" /f
	 )
 )

 ECHO:
 ECHO:
 ECHO Displaying All Windows Firewall Profile Settings on %@CONNECT% ...
 FOR %%p IN (%@FW_PROFILES%) DO REG QUERY "%@CONNECT%\%@FW_KEY%\%%~pProfile" /s


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                 