@ECHO OFF
 rem ==========================================================================
 rem === Determine OS In Logon Script
 rem ==========================================================================
 rem
 rem Created On: 03 Aug 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 03 Aug 2001
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem  	Alternate Tools ........ http://KB.ultratech-llc.com/?File=OSType.TXT
 rem ==========================================================================

 :::  This is the portion of the logon script where the OS is
 :::  determined so that the appropriate action can be taken
 :::  elsewhere in the logon script.  GETTYPE is only effective
 :::  in determining the differences between various version of
 :::  NT/2000, not Win9x and below, so the standard environment
 :::  variable check will be used for legacy Windows.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Determine OS Using Environment Variable and GETTYPE.EXE
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:DetermineOS
 IF NOT "%OS%"=="Windows_NT" GOTO :OldWindows
 FOR /F "TOKENS=3*" %%V IN ('GETTYPE') DO SET @OS=%%W
 SET @OS=%@OS:.=%
 IF /I "%@OS%"=="Windows 2000 Professional installation" GOTO :W2KPRO
 IF /I "%@OS%"=="Windows 2000 Server Domain Controller" GOTO :W2KDC
 IF /I "%@OS%"=="Windows 2000 Server Non-Domain Controller" GOTO :W2KMEM
 IF /I "%@OS%"=="Windows NT Workstation" GOTO :NT4W
 IF /I "%@OS%"=="Windows NT Server Domain Controller" GOTO :NT4DC
 IF /I "%@OS%"=="Windows NT Server Non-Domain Controller" GOTO :NT4MEM
 IF /I "%@OS%"=="Windows NT [Enterprise/Terminal] Server Domain Controller" GOTO :NT4TSDC
 IF /I "%@OS%"=="Windows NT [Enterprise/Terminal] Server Non-Domain Controller" GOTO :NT4TSMEM


 rem ==========================================================================
 rem === Win2K Professional Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:W2KPRO
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Win2K Domain Controller Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:W2KDC
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Win2K Member Server Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:W2KMEM
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === NT4 Workstation Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:NT4W
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === NT4 Domain Controller Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:NT4DC
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === NT4 Member Server Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:NT4MEM
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === NT4 Terminal Server Domain Controller Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:NT4TSDC
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === NT4 Terminal Server Member Server Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:NT4TSMEM
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Win3.x/Win9x/ME Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:OldWindows
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Common Section For All OSes
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:Common
 rem .... do stuff here for all OSes
 rem .... do stuff here for all OSes
 rem .... do stuff here for all OSes


 rem ==========================================================================
 rem === Exit Batch File
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:ExitBatch
 ECHO:
 ECHO ******************************
 ECHO *** Logon Script Completed ***
 ECHO ******************************
 ECHO:
 rem Stick a PAUSE statement here is you're debugging this script.
 ENDLOCAL
