@ECHO OFF
 rem ==========================================================================
 rem === Determine OS In Logon Script (using CMDINFO)
 rem ==========================================================================
 rem
 rem Created On: 03 Aug 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 03 Aug 2001
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	CMDINFO ................ http://www.savilltech.com/cmdinfo.html
 rem  	Alternate Tools ........ http://KB.ultratech-llc.com/?File=OSType.TXT
 rem ==========================================================================

 :::  This is the portion of the logon script where the OS is
 :::  determined so that the appropriate action can be taken
 :::  elsewhere in the logon script.  CMDINFO is only effective
 :::  in determining the differences between various versions of
 :::  NT/2000, not Win9x and below, so the standard environment
 :::  variable check will be used for legacy Windows.
 :::
 :::  This script only checks for differences in the OS, not
 :::  in the role of the OS, although both variables are set.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Determine OS Using Environment Variable and CMDINFO.EXE
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:DetermineOS
 IF NOT "%OS%"=="Windows_NT" GOTO :OldWindows
 FOR /F "TOKENS=3*" %%V IN ('CMDINFO ^| FIND /I "OS TYPE"') DO SET @OS=%%W
 FOR /F "TOKENS=3*" %%V IN ('CMDINFO ^| FIND /I "PRODUCT TYPE"') DO SET @ROLE=%%W
 IF /I "%@OS%"=="4.0" GOTO :NT4
 IF /I "%@OS%"=="Microsoft Windows 2000" GOTO :WIN2000
 IF /I "%@OS%"=="Microsoft Windows XP" GOTO :WINXP


 rem ==========================================================================
 rem === NT4 Section (Workstation, Server, etc)
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:NT4
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Windows 2000 Section (Pro, Server, etc)
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:WIN2000
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Windows XP Section (Home, Pro, Server, etc)
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:WINXP
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Win3.x/Win9x/ME Section
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:OldWindows
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 rem .... do stuff here for the appropriate OS
 GOTO :Common


 rem ==========================================================================
 rem === Common Section For All OSes
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:Common
 rem .... do stuff here for all OSes
 rem .... do stuff here for all OSes
 rem .... do stuff here for all OSes


 rem ==========================================================================
 rem === Exit Batch File
 rem === Last Modified On 03 Aug 2001
 rem ==========================================================================
:ExitBatch
 ECHO:
 ECHO ******************************
 ECHO *** Logon Script Completed ***
 ECHO ******************************
 ECHO:
 rem Stick a PAUSE statement here is you're debugging this script.
 ENDLOCAL
