@REM - ASB (05 Mar 2015 // 16 Oct 2023 / 19 Dec 2021 / 08 Dec 2021 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 13 Apr 2018 / 27 Mar 2016 / 20 May 2015): Execute the Highest Edition of OpenSSL Found On System
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.6.0.160

 SET @PROGFILES="%SystemDrive%\Programs\OpenSSL" "%SystemDrive%\Programs\OpenSSL-Win32" "%SystemDrive%\Programs\OpenSSL-Win64"
 SET @ROOTFILES=%@PROGFILES:\Programs\=\%
 SET @RUNAPP=
 SET @APPNAME=OpenSSL
 SET @APPEXE=bin\OpenSSL.exe


 rem -- Determine Appropriate Edition of %@APPNAME% to Run
:WhichEdition
 FOR %%P IN (%@ROOTFILES% %@PROGFILES%) DO IF EXIST "%%~P\%@APPEXE%" SET @RUNAPP="%%~P\%@APPEXE%"

 IF DEFINED @RUNAPP (
	 ECHO  Now Executing ....... %@RUNAPP% %*
	 START "" CMD /K %@RUNAPP% %*
	 ECHO:
	 ECHO  Finished Executing .. %@RUNAPP%
 ) ELSE (
	 ECHO No Edition of %@APPNAME% is installed on this machine...
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                                  