@ECHO OFF
 rem ==========================================================================
 rem === used to gather system information from windows machines
 rem ==========================================================================
 rem
 rem Created On: 20 Jun 2003
 rem         By: Steve Bossen
 rem
 rem Updated On: 17 Jul 2006  (Prior Update: 21 Jul 2003)
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem    now.exe ................ http://www.microsoft.com/windows2000/techinfo/reskit/tools/existing/now-o.asp
 rem    uptime.exe ............. http://www.microsoft.com/technet/archive/winntas/downloads/uptime.mspx
 rem    psinfo.exe ............. http://www.sysinternals.com/Utilities/PsInfo.html
 rem    psexec.exe ............. http://www.sysinternals.com/Utilities/PsExec.html
 rem    produkey.exe ........... http://www.nirsoft.net/utils/product_cd_key_viewer.html
 rem    srvinfo ................ is a utility from the windows 2000 resource kit
 rem
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem  	PSTOOLS ................ http://www.sysinternals.com/Utilities/PsTools.html
 rem ==========================================================================

 :::  author:  steve bossen - june 20, 2003
 :::  updated: steve bossen - july 17, 2006
 :::
 :::  This script uses some Microsoft Resource Kit utilities, along with a few
 :::  3rd party utilities (such as those from SysInternals.com) in order to to
 :::  capture running diagnostics info from remote systems.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 21 Jul 2003
 rem ==========================================================================
:NeedHelp
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Create Remote Report
 rem === Last Modified On 17 Jul 2006  (Prior Update: 21 Jul 2003)
 rem ==========================================================================
:Main
 TITLE now scanning %1...
 ECHO Creating PS Report for "%1"

 ( rem -- Consolidate LogFile Output
	 ECHO ************************************
	 ECHO *** start of report for %1
	 ECHO ************************************
	 now
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO  - Running PSINFO... >CON
	 ECHO ************************************
	 ECHO *** start of psinfo utility      ***
	 ECHO ************************************
	 ECHO:
	 psinfo \\%1 -s -d -h
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO  - Running SRVINFO... >CON
	 ECHO ************************************
	 ECHO *** start of srvinfo utility     ***
	 ECHO ************************************
	 ECHO:
	 srvinfo \\%1
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO  - Running TASKLIST... >CON
	 ECHO ************************************
	 ECHO *** start of tasklist utility    ***
	 ECHO ************************************
	 ECHO:
	 tasklist /s %1 /svc
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO  - Running IPCONFIG /ALL... >CON
	 ECHO ************************************
	 ECHO *** start of ipconfig /all       ***
	 ECHO ************************************
	 ECHO:
	 psexec \\%1 ipconfig /all
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO  - Running UPTIME... >CON
	 ECHO ************************************
	 ECHO *** start of uptime utility      ***
	 ECHO ************************************
	 ECHO:
	 uptime \\%1 /s /a
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO  - Running PRODUKEY... >CON
	 ECHO ************************************
	 ECHO *** start of produkey utility    ***
	 ECHO ************************************
	 ECHO:
	 produkey /remote %1 /stext "%TEMP%\%1.microsoft.keys.TXT"
	 produkey /remote %1 /shtml "%TEMP%\%1.microsoft.keys.htm"
	 TYPE "%TEMP%\%1.microsoft.keys.TXT"
	 ECHO:
	 ECHO See the following file for HTML Product Key Report:
	 ECHO  - "%TEMP%\%1.microsoft.keys.htm"
	 FOR /L %%C IN (1,1,3) DO ECHO:

	 ECHO ************************************
	 ECHO *** end of report for %1
	 ECHO ************************************
	 now
	 ECHO:
 ) >%1.TXT 2>NUL

 TITLE completed ps scan of %1...
 ECHO FINISHED Creating PS Report for "%1"
 ECHO:


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 17 Jul 2006  (Prior Update: 21 Jul 2003)
 rem ==========================================================================
:ExitBatch
 START NOTEPAD %1.TXT
 START "Microsoft Product Keys" "%TEMP%\%1.microsoft.keys.htm"
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 17 Jul 2006  (Prior Update: 21 Jul 2003)
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for PS.BAT
 ECHO:
 ECHO === PS [ip_address ^| host_name]
 ECHO:
 ECHO Example: PS 10.0.0.200
 ECHO          PS myserver
 ECHO:
