@ECHO OFF
 rem ==========================================================================
 rem === Set File Permissions for Home Directories
 rem ==========================================================================
 rem
 rem Created On: 14 Jul 2003
 rem         By: Scott Crawford
 rem
 rem Updated On: 02 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem    FILEACL ................ http://membres.lycos.fr/jfb/gb/gbtools/
 rem  	Alternate Tools ........ http://KB.ultratech-llc.com/?File=Perms.TXT
 rem ==========================================================================

 :::  author:  Scott Crawford
 :::
 :::  This script will set permissions on Home Directories for each
 :::  user using the very versatile FILEACL utility.
 :::
 :::  Domain name is "MYDOMAIN",
 :::  server name is "MYSERVER",
 :::  share name is "STAFF".
 :::  Fileacl.exe is in the root of the share.
 :::
 :::  Run "Perms username" from command line.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 21 Jul 2003
 rem ==========================================================================
:NeedHelp
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 02 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%
 SET @HOMEFOLDER=\\MYSERVER\STAFF
 SET @DOMAIN=MYDOMAIN


 rem ==========================================================================
 rem === Create Home Folders and Set Permissions
 rem === Last Modified On 21 Jul 2003
 rem ==========================================================================
:SetPerms
 md "%@HOMEFOLDER%\%1"
 md "%@HOMEFOLDER%\%1\Desktop"
 md "%@HOMEFOLDER%\%1\Favorites"
 md "%@HOMEFOLDER%\%1\My Documents"
 md "%@HOMEFOLDER%\%1\Templates"
 md "%@HOMEFOLDER%\%1\Web"

 %@HOMEFOLDER%\fileacl %@HOMEFOLDER%\%1 /INHERIT /SUB /FORCE /FILES /REPLACE
 %@HOMEFOLDER%\fileacl %@HOMEFOLDER%\%1 /s     "%@DOMAIN%\%1":f /d  "%@DOMAIN%\%1":WDDcOP/U/U /s "%@DOMAIN%\Web Users":RX/U/U
 %@HOMEFOLDER%\fileacl %@HOMEFOLDER%\%1 /d     "%@DOMAIN%\%1":PDO/U/U /SUB:1 /NOROOT
 %@HOMEFOLDER%\fileacl %@HOMEFOLDER%\%1\Web /s "%@DOMAIN%\Web Users":RX
 %@HOMEFOLDER%\fileacl %@HOMEFOLDER%\%1 /O     "%@DOMAIN%\%1" /SUB /FILES
 %@HOMEFOLDER%\fileacl %@HOMEFOLDER%\%1 /O Administrators /SUB:1


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 21 Jul 2003
 rem ==========================================================================
:ExitBatch
 ECHO:
 ECHO FINISHED Setting File Permissions on Home Directories for "%1"
 ECHO:
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 21 Jul 2003
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for PERMS.BAT
 ECHO:
 ECHO === Perms {username}
 ECHO:
 ECHO Example: Perms User1
 ECHO          Perms User2
 ECHO:
