@REM - ASB (29 Mar 2024 // 29 Mar 2024): Execute the 32-bit or 64-bit of PoolMon from Resource Kit Depending on OS
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.0.0.010

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @PROGFILES="%SystemDrive%\Programs" "%ProgramFiles(x86)%" "%ProgramFiles%"
 SET @APPNAME=PoolMon
 SET @APPEXE=PoolMon.exe
 SET @RUNAPP=


 rem -- Determine Appropriate Edition of %@APPNAME% to Run
:WhichEdition
 ECHO Searching for %@APPNAME% ...   Please Wait...
 ECHO:
 FOR %%P IN (%@PROGFILES%) DO FOR /F "TOKENS=*" %%F IN ('WHERE /R "%%~P" %@APPEXE% 2^>NUL ^| FIND /I "%@OS_ARCH%"') DO SET @RUNAPP="%%~F"

 IF DEFINED @RUNAPP (
	 ECHO  Now Executing ....... %@RUNAPP% %*
	 START "" %@RUNAPP% %*
	 ECHO:
	 ECHO  Finished Executing .. %@RUNAPP%
 ) ELSE (
	 ECHO No Edition of %@APPNAME% is installed on this machine...
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
