@REM - ASB (01 May 2014 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 26 Mar 2017): Create Dummy Administrator Account on Local Machine
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.6.0.090

 SET @LENGTH=%~1& IF "%~1"=="" SET @LENGTH=32
 SET @USE_RNDPASS=& FOR /F "TOKENS=*" %%F IN ('WHERE RandomPass 2^>NUL') DO SET @USE_RNDPASS=TRUE
 SET @PWD=%RANDOM%%TIME%
 SET @MSG=Built-in account for administering the computer/domain


 rem -- Create Dummy Administrator Account on Local Machine
:DummyAdmin
 ECHO Generating User Account Information...
 IF DEFINED @USE_RNDPASS FOR /F "TOKENS=*" %%P IN ('RANDOMPASS %@LENGTH% /C /E /Q /P') DO SET @PWD=%%P
 IF DEFINED @PWD SET @PWD=%@PWD:~-14%
 NET USER Administrator %@PWD% /comment:"%@MSG%" /ACTIVE:NO /PASSWORDCHG:NO /WORKSTATIONS:NONE /ADD
 CUSRMGR -u Administrator -p +s CanNotChangePassword +s AccountDisabled -c "%@MSG%"


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                                    