@REM - ASB (22 Dec 2010 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 29 Apr 2018 / 27 Mar 2016 / 05 May 2015): Query Registry for NTP Settings
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.10.0.200

 SET @NTP_KEY=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\W32Time
 SET @NTP_CLIENT_KEY=%@NTP_KEY%\TimeProviders\NtpClient
 SET @NTP_PARAM_KEY=%@NTP_KEY%\Parameters
 SET @NTP_CONFIG_KEY=%@NTP_KEY%\Config
 SET @EVENTS=11,17,22,29,35,37,38,47,50
 SET @DURATION=%~2& IF "%~2"=="" SET @DURATION=2
 SET @CNAME=%~1& IF "%~1"=="" SET @CNAME=%COMPUTERNAME%
 SET @CNAME=\\%@CNAME:\=%


 rem -- Determine Local NTP Settings
:Main
 IF EXIST "%@CNAME%\ADMIN$" (
	 W32TM /QUERY /COMPUTER:%~1 /PEERS | FIND /I "peer"
	 REG QUERY "%@CNAME%\%@NTP_CLIENT_KEY%"
	 REG QUERY "%@CNAME%\%@NTP_CONFIG_KEY%"
	 REG QUERY "%@CNAME%\%@NTP_PARAM_KEY%"
	 ECHO:
	 ECHO Searching Eventlog for NTP Events in Previous %@DURATION% Days...
	 PSLOGLIST %@CNAME% -I %@EVENTS% -D %@DURATION% -accepteula 2>NUL | FIND /I "NTP"
 ) ELSE (
	 ECHO *** COULD NOT CONNECT TO: %@CNAME%
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
     