@REM - ASB (28 Mar 2014 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 01 Sep 2019 / 13 Apr 2018 / 30 Apr 2017 / 27 Mar 2016): Execute the 32-bit or 64-bit of Recuva Depending on OS
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.8.0.180

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @OLDPATH=%PATH%
 SET @SCRIPTS=%~d0\Scripts
 SET @UTILS32=%@SCRIPTS%\Utils
 SET @UTILS64=%@SCRIPTS%\Utils\x64
 SET @APP32=%@UTILS32%\Recuva.exe
 SET @APP64=%@UTILS64%\Recuva64.exe

 rem -- Determine Appropriate OS
 IF /I "%@OS_ARCH%"=="x64" (
	 SET @NEWPATH=%@UTILS64%
	 SET @RUNAPP=%@APP64% %*
 ) ELSE (
	 SET @NEWPATH=%@UTILS32%
	 SET @RUNAPP=%@APP32% %*
 )


 rem -- Set Appropriate PATH and call Application
:CallMyApp
 ECHO  Now Executing ....... %@RUNAPP%
 PATH %@NEWPATH%;%PATH%
 %@RUNAPP%
 PATH %@OLDPATH%
 ECHO  Finished Executing .. %@RUNAPP%


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                                        