@REM - ASB (12 May 2005 // 28 Oct 2023 / 17 Oct 2023 / 30 Nov 2020 / 26 Dec 2019 / 24 Dec 2019 / 30 Sep 2019 / 10 Mar 2019 / 28 Feb 2019 / 11 Apr 2018): Install Scripts from Repository to Local System
@ECHO OFF
 CLS


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION

 rem -- Main Variables
 SET @SOURCE=%~dp0Scripts
 SET @DEST=%SystemDrive%\Scripts
 SET @INPUT=%@DEST%\BAT\Input
 SET @COPYEXEMPT=/EXCLUDE:%@SOURCE%\BAT\Input\[CopyExemption].TXT
 SET PATH=%@DEST%\BAT;%@DEST%\UTILS;%PATH%;%@SOURCE%\BAT;%@SOURCE%\UTILS

 rem -- Call Status Tracker Now, After PATH Updated
 CALL :ShowStatus "STARTED" v3.4.0.345


 rem -- Install Scripts from Repository to Local System
:Main
 ECHO Installing Scripts from Repository -- Please Wait...
 ECHO:
 CALL "%@SOURCE%\Bat\Acopy.BAT" "%@SOURCE%" "%@DEST%" %@COPYEXEMPT%
 CALL "%@DEST%\BAT\$NewSetup.BAT"


 rem -- Remove any Custom Input/Source Files for machines that are not the current one
:RemoveCustom
 IF "%~1"=="" (
	 CALL :DeleteOtherFiles "%@INPUT%\*.*.TXT"
	 CALL :DeleteOtherFiles "%@INPUT%\CustomVariables.MINI.*.TXT"
 )


 rem -- Remove the Logon Scripts folder for all non-Source systems
:RemoveLogonScripts
 IF "%~1"=="" IF EXIST "%@DEST%\BAT\LogonScripts" (
	 ECHO  - %@DEST%\BAT\LogonScripts
	 RD /S /Q "%@DEST%\BAT\LogonScripts"
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Delete Custom Input/Source Files for Other Machines
:DeleteOtherFiles
 rem %1 = Path/Folder Wildcard to Check

 IF "%~1"=="" GOTO :EOF
 FOR /F "TOKENS=*" %%C IN ('DIR /B /A "%~1" 2^>NUL ^| FIND /I /V ".%COMPUTERNAME%.TXT" ') DO (
	 ECHO  - %@INPUT%\%%~C
	 DEL "%@INPUT%\%%~C"
 )
 %@PAUSE_IF_DEBUG%
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                         