@REM - ASB (01 Apr 2015 // 16 Oct 2023 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 06 Nov 2018 / 12 Apr 2018 / 27 Mar 2016 / 16 Feb 2016): Re-run Scheduled Zip Jobs Running on Win8/2012/+
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v2.3.0.230

 rem -- Get Windows Build Info
 SET @BUILDINFO=%~dp0Input\[WindowsBuilds].TXT
 SET @VALID=%~1& IF "%~1"=="" SET @VALID="6.2.9200" "6.3.9600"
 IF EXIST "%@BUILDINFO%" FOR /F "USEBACKQ TOKENS=1-3 EOL=; DELIMS=. " %%V IN ("%@BUILDINFO%") DO (
	 FOR %%C IN (62 63 100) DO IF "%%~C"=="%%~V%%~W" SET @VALID=!@VALID! "%%~V.%%~W.%%~X"
 )
 SET @PROCEED=
 SET @COUNT=0


 rem -- Check Version
:CheckVersion
 FOR /F "TOKENS=4-6 DELIMS=[]. " %%V IN ('VER') DO SET @OSVER=%%V.%%W.%%X
 FOR %%V IN (%@VALID%) DO IF "%%~V"=="%@OSVER%" SET @PROCEED=TRUE
 IF NOT DEFINED @PROCEED (
	 ECHO Wrong OS Version.
	 ECHO -- Expecting Version ... %@VALID%
	 ECHO -- Found Version ....... %@OSVER%
	 GOTO :ExitBatch
 )


 rem -- Find and Run Specific Scheduled Jobs
:RunJobs
 FOR /F "TOKENS=3*" %%J IN ('SCHTASKS /V /FO LIST 2^>NUL ^| FIND /I "Task to Run:" ^| FINDSTR /I "\ZipLogs \ZipFiles"') DO (
	 SET /A @COUNT+=1
	 SET #!@COUNT!=%%K
	 ECHO Executing %%K
	 CALL %%K
 )


 rem -- Display Final Job Report
:FinalReport
 ECHO:
 SET #
 ECHO:
 IF EXIST "%~dp0TaskInfo.BAT" CALL "%~dp0TaskInfo.BAT" | FIND /I " Archive "


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                   