@REM - ASB (15 Nov 2017 // 16 Oct 2023 / 08 Dec 2021 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 13 Apr 2018 / 15 Nov 2017): Execute the Latest Edition of SQL Management Studio Found On System
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.5.0.050

 SET @PROGFILES="%SystemDrive%\Programs" "%ProgramFiles(x86)%" "%ProgramFiles%"
 SET @RUNAPP=
 SET @APPNAME=SSMS
 SET @APPVERS=10 20 30 40 50 60 70 80 90 100 110 120 130 140 150 160 170 180 190 200
 SET @APPPATH1=Microsoft SQL Server
 SET @APPPATH2=Tools\Binn\ManagementStudio\Ssms.exe


 rem -- Determine Appropriate Edition of %@APPNAME% to Run
:WhichEdition
 FOR %%P IN (%@PROGFILES%) DO FOR %%V IN (%@APPVERS%) DO IF EXIST "%%~P\%@APPPATH1%\%%~V\%@APPPATH2%" SET @RUNAPP="%%~P\%@APPPATH1%\%%~V\%@APPPATH2%"

 IF DEFINED @RUNAPP (
	 ECHO  Now Executing ....... %@RUNAPP% %*
	 START "" %@RUNAPP% %*
	 ECHO:
	 ECHO  Finished Executing .. %@RUNAPP%
 ) ELSE (
	 ECHO No Edition of %@APPNAME% is installed on this machine...
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
                                                                                                   