@ECHO OFF
 rem ==========================================================================
 rem === Send Logs via BLAT
 rem ==========================================================================
 rem
 rem Created On: 01 Jun 1999
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 30 Mar 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: Windows 2000 and later
 rem
 rem  Non-Native Utilities Required:
 rem  	BLAT ................... http://www.interlog.com/~tcharron/blat.html
 rem ==========================================================================

 :::  This script sends email (including attachments) using BLAT,
 :::  a command-line mailer.  This can be useful for sending logs
 :::  and reports to admin AT the end of various scheduled jobs.
 :::
 :::  Parameters can be entered AT the command line or hard-coded
 :::  into the script.  Parameters with spaces should be entered
 :::  with surrounded quotation marks.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 30 Mar 2003
 rem ==========================================================================
:Variables
 IF /I "%Debug%"=="TRUE" ECHO ON
 SETLOCAL
 FOR /F "TOKENS=*" %%F IN ('TIME /T') DO SET @TIME=%%F
 SET @SUMMARY=C:\TEMP\TEST.LOG
 SET @MAILPORT=25
 SET @MAILSERVER=mail.myserver.com
 SET @RCPT=-t Test@mydomain.com
 SET @FROM=Admin@mydomain.com
 SET @SUBJ=Test Message from %COMPUTERNAME% AT %@TIME%


 rem ==========================================================================
 rem === Process Commandline Parameters
 rem === Last Modified On 30 Mar 2003
 rem ==========================================================================
:Params
 IF /I "%~1"=="/H" GOTO :HelpMessage
 IF /I "%~1"=="/?" GOTO :HelpMessage
 FOR %%P IN (%*) DO CALL :GetParams %%P


 rem ==========================================================================
 rem === Send Test Mail
 rem === Last Modified On 30 Mar 2003
 rem ==========================================================================
:SendMail
 NOW This is Only A Test...  >"%@SUMMARY%"
 BLAT -install %@MAILSERVER% %@FROM% 5 %@MAILPORT%
 BLAT %@SUMMARY% %@RCPT% -s "%@SUBJ%"


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 15 Jan 2000
 rem ==========================================================================
:ExitBatch
 IF /I "%Debug%"=="TRUE" PAUSE
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Get Paramaters and Set Appropriate Variables
 rem === Last Modified On 30 Mar 2003
 rem ==========================================================================
:GetParams
 rem %1 = command option
 rem %2 = variable
 SET @PREFIX=%1
 SET @SUFFIX=%@PREFIX:~3,99%
 SET @PREFIX=%@PREFIX:~0,3%
 IF "%@SUFFIX%"=="" GOTO :EOF
 FOR %%V IN (M) DO IF /I "%@PREFIX%"=="/%%V:" SET @MAILSERVER=%@SUFFIX%
 FOR %%V IN (P) DO IF /I "%@PREFIX%"=="/%%V:" SET @MAILPORT=%@SUFFIX%
 FOR %%V IN (R) DO IF /I "%@PREFIX%"=="/%%V:" SET @RCPT=-t %@SUFFIX%
 FOR %%V IN (F) DO IF /I "%@PREFIX%"=="/%%V:" SET @FROM=%@SUFFIX%
 FOR %%V IN (S) DO IF /I "%@PREFIX%"=="/%%V:" SET @SUBJ=%@SUFFIX%
 GOTO :EOF


 rem ==============================================================================
 rem === SUBROUTINE: Display Syntax Help Message
 rem === Last Modified On 30 Mar 2003
 rem ==============================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for SENDMAIL.BAT
 ECHO:
 ECHO === SendMail [/D] {server_options}
 ECHO:
 ECHO Where SERVER_OPTIONS are as follows...
 ECHO:
 ECHO === /M:mailserver.domain.com
 ECHO === /P:mailserver port #
 ECHO === /R:recipient@domain.com
 ECHO === /F:sent_by@domain.com
 ECHO === /S:subject
 ECHO:
 ECHO Example: SendMail /M:mail.myserver.com /F:TestAcct@mydomain.com
 ECHO          SendMail /M:mymailserver /F:ExternalAcct@YourDomain.com
 ECHO          SendMail /M:mymailserver /F:ExternalAcct@YourDomain.com /P:26
 ECHO          SendMail /S:"Hello There"
 ECHO:
 PAUSE
