@REM - ASB (10 Dec 2011 // 16 Oct 2023 / 28 Feb 2022 / 30 Nov 2020 / 24 Dec 2019 / 30 Sep 2019 / 15 May 2018 / 27 Mar 2016 / 05 May 2015): Initialize Computer INPUT Files
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v2.1.0.210

 rem -- Obtain Date/Time and Supporting Core Variables
 FOR /F "TOKENS=1-2 DELIMS=;" %%P IN ('DATEINFO --Script-Variables 2^>NUL') DO SET %%P=%%~Q

 rem -- Main Variables
 SET @SOURCE=%SystemDrive%\Scripts\Bat\Input
 SET @FILEIOLIST=FileIO FileIO.Test
 SET @NAMELIST=AD-DCs Browser-Exempt ExchangeList ExchangeTest LowDisk MyServers SecurityList ServerList SmallList UptimeList
 SET @CFGLIST=ArchiveInfo CustomVariables
 SET @IPLIST=ServerIPList
 SET @REPO_LIST=ScriptSource
 SET @REPO_SHARE=\\%COMPUTERNAME%\Scripts_Source$\Scripts
 SET @REPO_FOLDER=%SystemDrive%\Storage\Scripts_Source\%COMPUTERNAME%\Scripts
 SET @CMD1=NETSH INTERFACE IP SHOW INTERFACES
 SET @CMD2=NETSH INTERFACE IP SHOW ADDRESSES
 SET @IP_INT=


 rem -- Determine if the config needs to be undone
:Undo
 SET @UNDO=& FOR %%V IN (/U -U /UN -UN /UNDO -UNDO) DO IF /I "%~1"=="%%~V" SET @UNDO=TRUE
 IF DEFINED @UNDO (
	 CALL :ShowHeader UNDO SOLO REPOSITORY CONFIGURATION
	 FOR %%S IN ("" ".%COMPUTERNAME%") DO (
		FOR %%F IN (%@FILEIOLIST% %@NAMELIST% %@IPLIST% %@REPO_LIST%) DO IF EXIST "%@SOURCE%\%%~F%%~S.TXT" DEL "%@SOURCE%\%%~F%%~S.TXT"
	 )
	 NET SHARE Scripts_Source$ /DELETE
	 GOTO :ExitBatch
 )


 rem -- Setup Script_Source Share
:ScriptSource
 CALL :ShowHeader CREATING ESSENTIAL FOLDERS
 FOR %%D IN ("%@SOURCE%" "%@REPO_FOLDER%") DO IF NOT EXIST "%%~D" MD "%%~D"
 NET SHARE Scripts_Source$="%@REPO_FOLDER%"


 rem -- Get IP Information
:GetIPInfo
 CALL :ShowHeader GET IP ADDRESS INFORMATION
 FOR /F "TOKENS=4*" %%I IN ('%@CMD1% ^| FIND " connected" ^| FIND /I /V "Loopback"') DO SET @IP_INT="%%~J" !@IP_INT!
 FOR %%I IN (%@IP_INT%) DO FOR /F "TOKENS=3" %%A IN ('%@CMD2% "%%~I" ^| FIND /I "IP ADDRESS"') DO SET @IPADDR=%%~A
 ECHO %@IPADDR%


 rem -- Initialize Current System in Various INPUT Files
:Main
 CALL :ShowHeader UPDATING INPUT FILES
 FOR %%S IN ("" ".%COMPUTERNAME%") DO (
	 FOR %%F IN (%@FILEIOLIST%) DO ECHO %COMPUTERNAME%, Storage$ >"%@SOURCE%\%%~F%%~S.TXT"
	 FOR %%F IN (%@NAMELIST%) DO   ECHO \\%COMPUTERNAME% >"%@SOURCE%\%%~F%%~S.TXT"
	 FOR %%F IN (%@IPLIST%) DO     ECHO %@IPADDR% >"%@SOURCE%\%%~F%%~S.TXT"
	 FOR %%F IN (%@REPO_LIST%) DO  ECHO "%@REPO_SHARE%", "%@REPO_FOLDER%", "" >"%@SOURCE%\%%~F%%~S.TXT"
 )
 CALL TimeStamp /T:@


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- Display Section Header
:ShowHeader
 rem %* = Heading to Display
 ECHO:
 ECHO %@DIVIDER*%
 ECHO *** %* for %COMPUTERNAME%
 ECHO %@DIVIDER*%
 ECHO:
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
     