@ECHO OFF
 rem ==========================================================================
 rem === Enable the ChangeTime Right on each Workstation
 rem ==========================================================================
 rem
 rem Created On: 13 Apr 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 03 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: NT4 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  This script uses NTRIGHTS from the NT/2000 ResKit to allow
 :::  Domain Users to change the Time on each workstation in the
 :::  domain (or for a specific list of machines).
 :::
 :::  If no list of systems is provided AT the command line, then
 :::  a list will be created of all of the machines in the domain
 :::  (as determined via the NET VIEW command).
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~1"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 03 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL

 rem -- Calculate Date/Time (Short Procedure - ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Standard Variables
 SET @GROUP=%~1
 SET @COMPLIST=%~2& IF "%~2"=="" SET @COMPLIST='NET VIEW'
 SET @RIGHT=SeSystemtimePrivilege
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Cycle Through Systems And Enable User Rights
 rem === Last Modified On 03 Dec 2003
 rem ==========================================================================
:AddRights
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Enabling The Following User Right: %@RIGHT% >"%@LOGFILE%"
 ECHO Getting a List of Computers via "%@COMPLIST%"...
 ECHO:
 FOR /F %%V IN (%@COMPLIST%) DO CALL :SetRights %%V
 ECHO Finished Enabling User Rights...
 ECHO:


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 03 Dec 2003
 rem ==========================================================================
:ExitBatch
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Set User Right On Each Machine (default TIME)
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:SetRights
 rem %1 = Current System To Be Updated
 SET @SYS=%1
 IF /I NOT "%@SYS:~0,2%"=="\\" GOTO :EOF
 ECHO:
 ECHO Enabling The Following User Right on "%1": %@RIGHT%
 ECHO Enabling The Following User Right on "%1": %@RIGHT% >>"%@LOGFILE%"
 NTRIGHTS -m %1 +r %@RIGHT% -u "%@GROUP%"
 IF ERRORLEVEL 1 (
   ECHO There were problems updating "%1"
   ECHO %1 - Could Not Update >>"%@LOGFILE%"
 )
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 05 Sep 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for TimeSync.BAT
 ECHO:
 ECHO === TimeSync {user_group} [list_of_servers.txt]
 ECHO:
 ECHO Example: TimeSync "MyDomain\Domain Users"
 ECHO          TimeSync ThisDomain\Users C:\TEMP\SERVERS.TXT
 ECHO          TimeSync ThatDomain\Users "C:\Input\List Of Servers.TXT"
 ECHO          TimeSync "OtherDomain\People" "'NET VIEW /DOMAIN:some_domain'"
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: If the name of the List of Servers or the
 ECHO       User Group contains spaces, it should be
 ECHO       surrounded by quotation marks.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
