@rem - ASB (09 Jan 2007 / 23 Nov 2011 / 23 Mar 2011): Provide SCHTASKS.EXE to Win2K Systems
@ECHO OFF
 CLS


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v1.1.1
 SET @SCHTASKS=%SystemDrive%\Scripts\Utils\System32\SCHTASKS.EXE

 SET @SOURCE=%~1& IF "%~1"=="." SET @SOURCE=%SystemDrive%\Scripts\BAT\Input\ServerList.%COMPUTERNAME%.TXT
 IF NOT EXIST "%@SOURCE%" SET @SOURCE=%SystemDrive%\Scripts\BAT\Input\ServerList.TXT


 rem -- Provide SCHTASKS.EXE to Win2K Systems
:UpdateEXE
 ECHO Preparing to copy SCHTASKS.EXE to all Win2K Systems [%@VER%]
 ECHO ---------------------------------------------------------------------------
 ECHO  List of Systems: "%@SOURCE%"
 ECHO ---------------------------------------------------------------------------
 ECHO:
 FOR /F "USEBACKQ" %%V IN ("%@SOURCE%") DO (
	 SET @MACHINE=%%~V
	 SET @MACHINE=\\!@MACHINE:\=!
	 SET @NEWSCHED=!@MACHINE!\Admin$\System32\SCHTASKS.EXE

	 IF NOT EXIST "!@NEWSCHED!" (
		 FOR /F "TOKENS=*" %%C IN ('COPY "%@SCHTASKS%" "!@NEWSCHED!" /V') DO ECHO  Copying SCHTASKS.EXE to !@MACHINE! -- %%C
	 ) ELSE (
		 ECHO !@MACHINE! already has a SCHTASKS.EXE file...
	 )
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" SET @VER=%~nx0 %~2
 IF /I "%~1"=="FINISHED" IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
 ECHO:
 ECHO *** %@SCRIPTSTATUS%: %@VER% [%DATE% at %TIME%] ***
 ECHO:
 GOTO :EOF
