@ECHO OFF
 rem ==========================================================================
 rem === View All File Permissions Combinations
 rem ==========================================================================
 rem
 rem Created On: 01 Jun 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Sep 2001
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: Windows 2000 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem ==========================================================================

 :::  Win2K Version of the Script...
 :::  This script will enumerate all of the possible variations
 :::  of file and directory permissions using the Guest Account.
 :::  To obtain the syntax for XCACLS, type: XCACLS /?
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 06 Sep 2001
 rem ==========================================================================
:NeedHelp
 IF "%~1"=="" GOTO :HelpMessage
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 23 Aug 2001
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @DIR=%1
 SET @FILE="%@DIR%\Cacls.TMP"
 SET @ACCT="GUEST"
 SET @PERMS=F C R P O X E W D


 rem ==========================================================================
 rem === Generate Permissions Permutations
 rem === Last Modified On 01 Jun 2001
 rem ==========================================================================
:Permutations
 MD "%@DIR%" 2>NUL
 ECHO: >%@FILE%

 ECHO Generating All Variations of Permissions For "%@DIR%"
 ECHO:
 FOR %%I IN (%@PERMS%) DO (
   CALL :ShowACLs %%I
   FOR %%J IN (%@PERMS%) DO (
     CALL :ShowACLs %%I;%%J
     CALL :ShowACLs %%I;T%%J
   )
 )


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 01 Jun 2001
 rem ==========================================================================
:ExitBatch
 DEL "%@FILE%" 2>NUL
 RD /Q "%@DIR%" 2>NUL
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Each ACLs Variation
 rem === Last Modified On 01 Jun 2001
 rem ==========================================================================
:ShowACLs
 rem - %* = File/Folder Permissions
 ECHO:
 ECHO Setting The Following Permissions: "%*"
 XCACLS "%@DIR%\*.*" /Y /P "Administrators":F %@ACCT%:%* >NUL
 XCACLS "%@DIR%"     /Y /P "Administrators":F %@ACCT%:%* >NUL
 XCACLS "%@DIR%" | FIND /I /V "Administrators"
 FOR /F "TOKENS=2*" %%P IN ('SHOWACLS "%@DIR%" ^| FIND /I %@ACCT%') DO ECHO SHOWACLS = "%%P %%Q"
 ECHO -------------------------------------------------------------
 ECHO:
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 23 Aug 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for VIEWPERMS.BAT
 ECHO:
 ECHO === ViewPerms [directory_to_view]
 ECHO:
 ECHO Example: ViewPerms C:\Stuff
 ECHO          ViewPerms D:\Other\Files
 ECHO          ViewPerms E:\Some\Short\Folder\Name
 ECHO          ViewPerms "F:\Some Long Folder\Name"
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: Folder names which contain spaces
 ECHO       should be surrounded by quotes.
 ECHO       Shortnames *can* be surrounded by
 ECHO       quotes if you choose, but it is not
 ECHO       mandatory by any means.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
