@ECHO OFF
 rem ==========================================================================
 rem === Find Out What Processes Are Being Spawned By SVCHOST
 rem ==========================================================================
 rem
 rem Created On: 24 Dec 2001
 rem         By: Andrew S. Baker
 rem
 rem Updated On: 06 Dec 2003
 rem         By: Andrew S. Baker
 rem


 rem ==========================================================================
 rem  OS Required: Windows 2000 or later
 rem
 rem  Non-Native Utilities Required:
 rem  	Resource Kit ........... http://KB.ultratech-llc.com/?File=ResKit.TXT
 rem  	Alternate Tools ........ http://KB.ultratech-llc.com/?File=Processes.TXT
 rem ==========================================================================

 :::  This script uses TLIST, which can be found in the Win2K
 :::  Resource Kit, but is a native WinXP utility.  The WinXP
 :::  version of this command has more functionality than the
 :::  Win2K version, and will return more info.
 :::
 :::  For More Scripting Assistance, see the following:
 :::  http://KB.ultratech-llc.com/?File=Scripting.TXT


 rem ==========================================================================
 rem === Display Syntax Help if Required/Requested
 rem === Last Modified On 24 Dec 2001
 rem ==========================================================================
:NeedHelp
 FOR /F "TOKENS=2" %%H IN ('CHECKPARAMS -q -c "H HELP ?" -s %* 2^>NUL') DO GOTO :HelpMessage


 rem ==========================================================================
 rem === Initialize Environment Variables
 rem === Last Modified On 03 Dec 2003
 rem ==========================================================================
:Variables
 SETLOCAL
 SET @STORAGE=%SystemDrive%\STORAGE& IF EXIST "%~dp0SetDrive.BAT" CALL "%~dp0SetDrive.BAT"

 rem -- Calculate Date/Time (Short Procedure - ResKit)
 FOR /F "TOKENS=2-5 DELIMS=/ " %%D IN ('DATE /T') DO SET @TODAY=%%F%%D%%E
 FOR /F "TOKENS=4-6 DELIMS=: " %%T IN ('NOW') DO SET @NOW=%%T%%U%%V
 SET @FILESTAMP=%@TODAY%-%@NOW%.LOG

 rem -- Standard Variables
 SET @PROCESS=SVCHOST
 SET @TASKEXE=svchost.exe
 SET @LOGPATH=%@STORAGE%\Logs\Maint
 SET @LOGFILE=%@LOGPATH%\%~n0.%@FILESTAMP%


 rem ==========================================================================
 rem === Parse Task/Process List For SVCHOST
 rem === Last Modified On 03 Dec 2003
 rem ==========================================================================
:GetProcess
 IF NOT EXIST "%@LOGPATH%" MD "%@LOGPATH%"

 NOW Searching for the following process: "%@PROCESS%" >"%@LOGFILE%"
 ECHO Searching for the following process: "%@PROCESS%"
 ECHO:
 FOR /F "TOKENS=1-3*" %%P IN ('TLIST -S ^| FIND /I "%@PROCESS%"') DO CALL :MoreInfo %%P %%Q "%%S"


 rem ==========================================================================
 rem === Reset Environment Variables and Exit Batch File
 rem === Last Modified On 06 Dec 2003
 rem ==========================================================================
:ExitBatch
 TYPE "%@LOGFILE%" & DIR "%@LOGFILE%"
 ENDLOCAL
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Breakout Process Info
 rem === Last Modified On 24 Dec 2001
 rem ==========================================================================
:MoreInfo
 rem %1 = PID of Current Process
 rem %2 = Name of Current Process
 rem %3 = Services Associated With Current Process

 IF /I NOT "%2"=="%@TASKEXE%" GOTO :EOF
 TLIST %1 | FIND /I "Cmdline:" >>"%@LOGFILE%"
 ECHO Process ID: %1           >>"%@LOGFILE%"
 ECHO   Services: %~3          >>"%@LOGFILE%"
 ECHO:                         >>"%@LOGFILE%"
 GOTO :EOF


 rem ==========================================================================
 rem === SUBROUTINE: Display Syntax Help For "/?"
 rem === Last Modified On 24 Dec 2001
 rem ==========================================================================
:HelpMessage
 ECHO:
 ECHO Syntax Help for WHATSVC.BAT
 ECHO:
 ECHO === WhatSVC
 ECHO:
 ECHO Example: WhatSVC SVCHOST
 ECHO:
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO NOTE: Process Names which contain spaces
 ECHO       should be surrounded by quotation marks.
 ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ECHO:
