@REM - ASB (18 May 2015 // 16 Oct 2023 / 08 Dec 2021 / 14 Nov 2021 / 18 Sep 2020 / 24 Dec 2019 / 30 Sep 2019 / 13 Apr 2018 / 11 Apr 2017 / 27 Mar 2016): Execute the Edition of Microsoft Word (or Alternative) Found On System
@ECHO OFF


 rem -- Generate Filtered CMD Title
:DisplayTitle
 SET @TTT= %*
 SET @TTT=%@TTT:/?={HELP}%
 TITLE [%USERDOMAIN%\%USERNAME%] - %~f0 %@TTT% >NUL 2>NUL
 SET @TTT=


 rem -- Initialize Environment Variables
:Variables
 SETLOCAL ENABLEDELAYEDEXPANSION & CALL :ShowStatus "STARTED" v2.2.0.080

 SET @PROGFILES="%SystemDrive%\Programs" "%ProgramFiles(x86)%" "%ProgramFiles%"
 SET @RUNAPP=
 SET @APPNAME=Microsoft Word [or alternative]
 SET @APPEXE1=Microsoft Office\Office##\WinWord.EXE
 SET @APPEXE2=Microsoft Office\root\Office##\WinWord.EXE
 SET @APPEXE3=SoftMaker FreeOffice 20##\TextMaker.EXE


 rem -- Determine Appropriate Edition of %@APPNAME% to Run
:WhichEdition
 FOR %%P IN (%@PROGFILES%) DO FOR /L %%V IN ( 1,1,30) DO IF EXIST "%%~P\!@APPEXE1:##=%%V!" SET @RUNAPP="%%~P\!@APPEXE1:##=%%V!"
 FOR %%P IN (%@PROGFILES%) DO FOR /L %%V IN ( 1,1,30) DO IF EXIST "%%~P\!@APPEXE2:##=%%V!" SET @RUNAPP="%%~P\!@APPEXE2:##=%%V!"
 FOR %%P IN (%@PROGFILES%) DO FOR /L %%V IN (18,1,30) DO IF EXIST "%%~P\!@APPEXE3:##=%%V!" SET @RUNAPP="%%~P\!@APPEXE3:##=%%V!"

 IF DEFINED @RUNAPP (
	 ECHO  Now Executing ....... %@RUNAPP% %*
	 START "" %@RUNAPP% %*
	 ECHO:
	 ECHO  Finished Executing .. %@RUNAPP%
 ) ELSE (
	 ECHO No Edition of %@APPNAME% is installed on this machine...
 )


 rem -- Reset Environment Variables and Exit Batch File
:ExitBatch
 CALL :ShowStatus "FINISHED"
 ENDLOCAL
 GOTO :EOF


 rem -- SUBROUTINE: Set/Display Script Version and Execution Status (STARTED/FINISHED)
:ShowStatus
 rem %1 = Run Status of Script
 rem %2 = Current Application Version

 IF NOT DEFINED @DATEFMT SET @DATEFMT=-F "mm/dd/yyyy hh:nn:ss.zzz"
 SET @SCRIPTSTATUS=%~1& IF "%~1"=="" SET @SCRIPTSTATUS=RUNNING
 IF NOT "%~2"=="" (SET @VER=%~nx0 %~2& SET @VERSION=%~2)
 IF /I "%~1"=="STARTED" FOR /F "TOKENS=*" %%d IN ('DATEINFO -S %@DATEFMT% -Q 2^>NUL') DO SET @SCRIPT_BEG#="%%~d"
 IF /I "%~1"=="FINISHED" (
	 IF DEFINED $CODEPAGE FOR /F "TOKENS=1* DELIMS=:" %%B IN ('CHCP %$CODEPAGE%') DO SET @CHCP_STATUS= {Restoring Code Page:%%C}
	 IF DEFINED @END_DEBUG_MODE %@END_DEBUG_MODE:"=%
	 TITLE Command Prompt [%USERDOMAIN%\%USERNAME%]   !@DEBUG_MODE!
	 DATEINFO -t %@SCRIPT_BEG#% -e "hr:min:sec.ms" -o "\n*** DURATION: " 2>NUL
 )
 NOW \n*** %@SCRIPTSTATUS%: %@VER% [\v] *** %@CHCP_STATUS%\n!@CRLF-%~1!
 GOTO :EOF
               